      subroutine block_info(ise,nx)
      use mod_dmrg
      implicit none
      integer :: ise,nx,ib,i,it,ista,iend,lsta,lend,mem0,mem1

! --- COMFIMATION OF MEMORY USAGE
      if(allocated(block(ise,nx)%b)) then
        mem0=0; mem1=0
!$OMP PARALLEL DO REDUCTION(+:mem0,mem1)
        do ib=1,block(ise,nx)%nbk
          do i=1,nfr
            if(allocated(block(ise,nx)%b(ib)%s(i)%uv)) then
              mem0=mem0+8*size(block(ise,nx)%b(ib)%s(i)%uv)
            end if
          enddo
          if(allocated(block(ise,nx)%b(ib)%hm)) then
            mem1=mem1+8*size(block(ise,nx)%b(ib)%hm)
          end if
        enddo
        mem_uv=mem_uv-mem0
        mem_hm=mem_hm-(1+2*id_hop)*mem1
      end if

! --- BLOCK INFO.
      if(allocated(block(ise,nx)%nud)) deallocate(block(ise,nx)%nud)
      if(allocated(block(ise,nx)%b2b)) deallocate(block(ise,nx)%b2b)
      if(allocated(block(ise,nx)%size)) deallocate(block(ise,nx)%size)
      if(allocated(block(ise,nx)%size0)) deallocate(block(ise,nx)%size0)
      if(allocated(block(ise,nx)%sizex)) deallocate(block(ise,nx)%sizex)
      if(allocated(block(ise,nx)%stax)) deallocate(block(ise,nx)%stax)
      if(allocated(block(ise,nx)%nse)) deallocate(block(ise,nx)%nse)
      if(allocated(block(ise,nx)%b)) deallocate(block(ise,nx)%b)
      if(allocated(block(ise,nx)%kid)) deallocate(block(ise,nx)%kid)

      if(allocated(block(ise,nx)%ista0)) deallocate(block(ise,nx)%ista0)
      if(allocated(block(ise,nx)%iend0)) deallocate(block(ise,nx)%iend0)
      if(allocated(block(ise,nx)%isize0))
     &  deallocate(block(ise,nx)%isize0)

      if(allocated(block(ise,nx)%ista)) deallocate(block(ise,nx)%ista)
      if(allocated(block(ise,nx)%iend)) deallocate(block(ise,nx)%iend)
      if(allocated(block(ise,nx)%isize))
     &  deallocate(block(ise,nx)%isize)

      if(allocated(block(ise,nx)%chbk)) deallocate(block(ise,nx)%chbk)

      allocate(block(ise,nx)%nud(nbk,2),
     &         block(ise,nx)%b2b(nbk,-1:1,nop),
     &         block(ise,nx)%size(nbk),
     &         block(ise,nx)%size0(nbk),
     &         block(ise,nx)%sizex(nbk,nfr),
     &         block(ise,nx)%stax(nbk,nfr),
     &         block(ise,nx)%b(nbk),
     &         block(ise,nx)%nse(nbk,nfr),
     &         block(ise,nx)%kid(nbk),
     &         block(ise,nx)%ista0(nbk,2),
     &         block(ise,nx)%iend0(nbk,2),
     &         block(ise,nx)%isize0(nbk,2),
     &         block(ise,nx)%ista(nbk,2),
     &         block(ise,nx)%iend(nbk,2),
     &         block(ise,nx)%isize(nbk,2),
     &         block(ise,nx)%chbk(nbk))

      block(ise,nx)%nbk=tempb(1)%nbk   !# of blocks in system or environment block
      block(ise,nx)%isbk=tempb(1)%isbk
      block(ise,nx)%iebk=tempb(1)%iebk
      block(ise,nx)%isbk1=tempb(1)%isbk1
      block(ise,nx)%iebk1=tempb(1)%iebk1
      block(ise,nx)%isbk2=tempb(1)%isbk2
      block(ise,nx)%iebk2=tempb(1)%iebk2
      block(ise,nx)%isbk3=tempb(1)%isbk3
      block(ise,nx)%iebk3=tempb(1)%iebk3
      block(ise,nx)%isbk4=tempb(1)%isbk4
      block(ise,nx)%iebk4=tempb(1)%iebk4

      block(ise,nx)%ndmx=tempb(1)%ndmx   !dimension of system or environment block

      mem0=0
!$OMP PARALLEL DO PRIVATE(ista,iend,lsta,lend) REDUCTION(+:mem0)
      do ib=1,nbk
        allocate(block(ise,nx)%b(ib)%s(nfr))
        call para_range(1,tempb(1)%size0(ib),np_sys,myid_sys,ista,iend)
        do i=1,nfrx(ise)
          call para_range(1,tempb(1)%sizex(ib,i),np_env,myid_env,
     &                    lsta,lend)
          allocate(block(ise,nx)%b(ib)%s(i)%uv(lsta:lend,ista:iend))
          mem0=mem0+8*size(block(ise,nx)%b(ib)%s(i)%uv)
          block(ise,nx)%b(ib)%s(i)%uv=tempb(1)%b(ib)%s(i)%uv   !transformation matrix
        enddo

        block(ise,nx)%size0(ib)=tempb(1)%size0(ib)   !original block size

        block(ise,nx)%kid(ib)=tempb(1)%kid(ib)  !node of block

        block(ise,nx)%isize0(ib,1)=tempb(1)%isize0(ib,1)   !parallelized original block size (system)
        block(ise,nx)%ista0(ib,1)=tempb(1)%ista0(ib,1)
        block(ise,nx)%iend0(ib,1)=tempb(1)%iend0(ib,1)

        block(ise,nx)%isize0(ib,2)=tempb(1)%isize0(ib,2)   !parallelized original block size (environment)
        block(ise,nx)%ista0(ib,2)=tempb(1)%ista0(ib,2)
        block(ise,nx)%iend0(ib,2)=tempb(1)%iend0(ib,2)

        do it=1,nop   !change block by interactions
          do i=-1,1
            block(ise,nx)%b2b(ib,i,it)=tempb(1)%b2b(ib,i,it)
          enddo
        enddo

        block(ise,nx)%nud(ib,1)=tempb(1)%nud(ib,1)   !# of spin-up at each node
        block(ise,nx)%nud(ib,2)=tempb(1)%nud(ib,2)   !# of spin-down at each node

        do i=1,nfr
          block(ise,nx)%nse(ib,i)=tempb(1)%nse(ib,i)   !state (array number) of block
          block(ise,nx)%sizex(ib,i)=tempb(1)%sizex(ib,i)   !block size for block and added site
          block(ise,nx)%stax(ib,i)=tempb(1)%stax(ib,i)     !starting point of array
        enddo

        block(ise,nx)%size(ib)=tempb(1)%size(ib)   !size of transformed block

        do i=1,2
          block(ise,nx)%isize(ib,i)=tempb(1)%isize(ib,i)   !parallelized by system's or environment' MPI
          block(ise,nx)%ista(ib,i)=tempb(1)%ista(ib,i)
          block(ise,nx)%iend(ib,i)=tempb(1)%iend(ib,i)
        enddo

        block(ise,nx)%chbk(ib)=tempb(1)%chbk(ib)

      enddo

      mem_uv=mem_uv+mem0

      return
      end
