      subroutine ck_hamil_2(ckx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,iop,nck1,nck2,i1,i2
      integer,allocatable :: ick(:,:),iwk(:)
      type(ck_h) :: ckx(nh2,0:2)

      do id=0,2
C --- BLOCK--BLOCK
C ----- CHECKING SYSTEM OR ENVIRONMENT
        if(id.eq.0) then
          allocate(ick(nsite,2))
!$OMP PARALLEL WORKSHARE
          ick=0
!$OMP END PARALLEL WORKSHARE
!$OMP PARALLEL DO REDUCTION(+:ick)
          do iop=1,nh2
            if(hamil(iop)%ihs(1).lt.iad(1)) then
              if(hamil(iop)%ihs(2).gt.iad(2)) then !SYS.BLOCK--ENV.BLOCK
                ick(hamil(iop)%ihs(1),1)=ick(hamil(iop)%ihs(1),1)+1
                ick(hamil(iop)%ihs(2),2)=ick(hamil(iop)%ihs(2),2)+1
              end if
            end if
          enddo

          nck1=0; nck2=0
!$OMP PARALLEL DO REDUCTION(+:nck1,nck2)
          do iop=1,nsite
            if(ick(iop,1).ne.0) then
              nck1=nck1+1
            end if
            if(ick(iop,2).ne.0) then
              nck2=nck2+1
            end if
          enddo
          deallocate(ick)

          if(nck1.ge.nck2) then
            i1=1; i2=2
          else
            i1=2; i2=1
          end if
        else
          i1=2-mod(id,2)
          i2=1+mod(id,2)
        end if

        allocate(ick(nsite,1))
!$OMP PARALLEL WORKSHARE
        ick=0
!$OMP END PARALLEL WORKSHARE
!$OMP PARALLEL DO
        do iop=1,nh2
          allocate(ckx(iop,id)%num(2))
          ckx(iop,id)%num=0
        enddo

C ----- COUNTING
        if(id.eq.0) then
          do iop=1,nh2
            if(hamil(iop)%ihs(1).lt.iad(1)) then !SYSTEM
              if(hamil(iop)%ihs(2).gt.iad(2)) then !ENVIRONMENT
                if(ick(hamil(iop)%ihs(i2),1).eq.0) then
                  ick(hamil(iop)%ihs(i2),1)=iop
                end if
              end if
            end if
          enddo
        else
          do iop=1,nh2
            if(hamil(iop)%ihs(i2).eq.iad(1).or.
     &        hamil(iop)%ihs(i2).eq.iad(2)) then !ADDED
              if(hamil(iop)%ihs(1).lt.iad(1).or.
     &           hamil(iop)%ihs(2).gt.iad(2)) then
                if(ick(hamil(iop)%ihs(i2),1).eq.0) then
                  ick(hamil(iop)%ihs(i2),1)=iop
                end if
              end if
            end if
          enddo
        end if

!$OMP PARALLEL DO
        do iop=1,nsite
          if(ick(iop,1).ne.0) ckx(ick(iop,1),id)%num(i2)=1
        enddo

        allocate(iwk(nh2))
!$OMP PARALLEL WORKSHARE
        iwk=0
!$OMP END PARALLEL WORKSHARE

        if(id.eq.0) then
!$OMP PARALLEL DO REDUCTION(+:iwk)
          do iop=1,nh2
            if(hamil(iop)%ihs(1).lt.iad(1)) then
              if(hamil(iop)%ihs(2).gt.iad(2)) then !SYS.BLOCK--ENV.BLOCK
                iwk(ick(hamil(iop)%ihs(i2),1))
     &            =iwk(ick(hamil(iop)%ihs(i2),1))+1
              end if
            end if
          enddo
        else
!$OMP PARALLEL DO REDUCTION(+:iwk)
          do iop=1,nh2
            if(hamil(iop)%ihs(i2).eq.iad(1).or.
     &         hamil(iop)%ihs(i2).eq.iad(2)) then !ADDED
              if(hamil(iop)%ihs(1).lt.iad(1).or.
     &           hamil(iop)%ihs(2).gt.iad(2)) then
                iwk(ick(hamil(iop)%ihs(i2),1))
     &            =iwk(ick(hamil(iop)%ihs(i2),1))+1
              end if
            end if
          enddo
        end if
!$OMP PARALLEL DO
        do iop=1,nh2
          ckx(iop,id)%num(i1)=iwk(iop)
        enddo
        deallocate(iwk)

C ----- SETTING
!$OMP PARALLEL DO
        do iop=1,nh2
          if(ckx(iop,id)%num(1)*ckx(iop,id)%num(2).eq.0) cycle
          allocate(ckx(iop,id)%ist(ckx(iop,id)%num(i1),2))
          ckx(iop,id)%ist(1,i2)=ick(hamil(iop)%ihs(i2),1)
        enddo

        if(id.eq.0) then
          do iop=1,nh2
            ckx(iop,id)%num(i1)=0
            if(hamil(iop)%ihs(1).lt.iad(1)) then
              if(hamil(iop)%ihs(2).gt.iad(2)) then !SYS.BLOCK--ENV.BLOCK
                ckx(ick(hamil(iop)%ihs(i2),1),id)%num(i1)
     &            =ckx(ick(hamil(iop)%ihs(i2),1),id)%num(i1)+1
                ckx(ick(hamil(iop)%ihs(i2),1),id)
     &            %ist(ckx(ick(hamil(iop)%ihs(i2),1),id)%num(i1),i1)=iop
              end if
            end if
          enddo
        else
          do iop=1,nh2
            ckx(iop,id)%num(i1)=0
            if(hamil(iop)%ihs(i2).eq.iad(1).or.
     &         hamil(iop)%ihs(i2).eq.iad(2)) then !ADDED
              if(hamil(iop)%ihs(1).lt.iad(1).or.
     &           hamil(iop)%ihs(2).gt.iad(2)) then
                ckx(ick(hamil(iop)%ihs(i2),1),id)%num(i1)
     &            =ckx(ick(hamil(iop)%ihs(i2),1),id)%num(i1)+1
                ckx(ick(hamil(iop)%ihs(i2),1),id)
     &            %ist(ckx(ick(hamil(iop)%ihs(i2),1),id)%num(i1),i1)
     &            =iop
              end if
            end if
          enddo
        end if
        deallocate(ick)

      enddo

      return
      end
