      module communication_s
      implicit none
      include 'mpif.h'

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  get_loop_start  : calculate a local loop start position from the
!                    global loop start position.
!  get_loop_end    : calculate a local loop end position from the
!                    global loop end position.
!  get_owner_node  : calculate number of the specified rank.
!  translate_g2l   : calculate a local array index from a global array
!                    index.
!  translate_l2g   : calculate a global array index from a local array
!                    index.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      public  :: get_loop_start
      public  :: get_loop_end
      public  :: translate_l2g

      private :: ierr

      integer :: ierr

      contains
!----
      integer function get_loop_start(istart, nnod, inod)
      implicit none
      integer, intent(in)    :: istart, nnod, inod

      get_loop_start = (istart+nnod-1-inod)/nnod+1

      return
      end function ! get_loop_start
!----
      integer function get_loop_end(iend, nnod, inod)
      implicit none
      integer, intent(in)    :: iend, nnod, inod

      get_loop_end   = (iend  +nnod  -inod)/nnod+0

      return
      end function ! get_loop_end
!----
      integer function translate_l2g(ictr, nnod, inod)
      implicit none
      integer, intent(in)    :: ictr, nnod, inod

      translate_l2g   = (ictr-1)*nnod+inod

      return
      end function ! translate_l2g

      end module communication_s
