      subroutine current_1D(iv)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv,ix,iy,ista,iend,mx_i0,mx_i,ip
      complex(8) :: res0,res1,res2,res,rp
      complex(8),allocatable :: res_a0(:)
      type(inop) :: tp(1)
      type(avec),allocatable :: va(:)

      if(myid_dmrg.eq.key_rank.and.np_int.eq.1) then
        write(iso,*)
        write(iso,'(1x,a)') '# current'
      end if

! --- PARAMETERS OF PARALLELIZATION
      mx_i0=0
      call para_range(1,nh2,np_int,myid_int,ista,iend)
      do ix=ista,iend
        if(hamil(ix)%ihs(1).eq.hamil(ix)%ihs(2)) cycle
        mx_i0=mx_i0+1
      enddo
      call mpi_allreduce(mx_i0,mx_i,1,mpi_integer,mpi_sum,newcomm_int,
     &                   ierr)

      allocate(res_a0(ista:iend))

! --- INITIALIZE
      allocate(va(isbk0:iebk0))
      call phys_int(iv,va)
      call para_range(1,nh2,np_int,myid_int,ista,iend)

! --- CALCULATING PHYSICAL QUANTITIES
      allocate(tp(1)%ni(2),tp(1)%ki(2))
      res2=zero
      tp(1)%mi=2 !number of operator
      tp(1)%fi=1 !1:add to res0
      do ix=ista,iend
        if(hamil(ix)%ihs(1).eq.hamil(ix)%ihs(2)) cycle
        tp(1)%ni(1)=minval(hamil(ix)%ihs) !site number 1
        tp(1)%ni(2)=maxval(hamil(ix)%ihs) !site number 2

        res1=zero
        do iy=1,2
          tp(1)%ki=(/iy,-iy/) !operator number
          call phys_cal(va,tp(1),1,res0)
          if(hamil(ix)%ihs(1).eq.1.and.
     &       hamil(ix)%ihs(2).eq.nsite) then !PBC
            rp=res0*ps
            rp=(conjg(rp)-rp)
            res1=res1
     &           +ht(iy)*hamil(ix)%vh(1)*rp
          else
            rp=res0*conjg(ps)
            rp=(rp-conjg(rp))
            res1=res1
     &           +ht(iy)*hamil(ix)%vh(1)*rp
          end if
        enddo

        res_a0(ix)=res1
        if(myid_dmrg.eq.key_rank.and.np_int.eq.1) then
          write(iso,'(2x,I4,2x,I4,1x,f12.7)')
     &      tp(1)%ni,-aimag(res1)
        end if

        res2=res2+res1
      enddo

      call mpi_allreduce(res2,res,1,mpi_kv,mpi_sum,newcomm_int,ierr)

! --- OUTPUT
      if(np_int.gt.1) then
        if(myid_tm.eq.0) then
          if(myid_int.eq.0) then
            write(iso,*)
            do ix=ista,iend
              write(iso,'(2x,I4,2x,I4,1x,f12.7)')
     &          minval(hamil(ix)%ihs),maxval(hamil(ix)%ihs),
     &          -aimag(res_a0(ix))
            enddo
          end if
          allocate(mpist(MPI_STATUS_SIZE))
          do ip=2,np_int
            if(ip-1.eq.myid_int) then
              call mpi_send(ista,1,mpi_integer,0,ip,newcomm_int,ierr)
              call mpi_send(iend,1,mpi_integer,0,ip*10,newcomm_int,ierr)
              call mpi_send(res_a0,iend-ista+1,mpi_kv,0,ip*20,
     &                      newcomm_int,ierr)
            elseif(myid_int.eq.0) then
              call mpi_recv(ista,1,mpi_integer,ip-1,ip,newcomm_int,
     &                      mpist,ierr)
              call mpi_recv(iend,1,mpi_integer,ip-1,ip*10,newcomm_int,
     &                      mpist,ierr)
              deallocate(res_a0)
              allocate(res_a0(ista:iend))
              call mpi_recv(res_a0,iend-ista+1,mpi_kv,ip-1,ip*20,
     &                      newcomm_int,mpist,ierr)
              do ix=ista,iend
                write(iso,'(2x,I4,2x,I4,1x,f12.7)')
     &            minval(hamil(ix)%ihs),maxval(hamil(ix)%ihs),
     &            -aimag(res_a0(ix))
              enddo
            end if
          enddo
          deallocate(mpist)
        end if
      end if

      deallocate(res_a0)

      if(myid_dmrg.eq.key_rank) then
        write(iso,'(2x,a,f12.7)') '(current): ',-aimag(res) !i*i
        open(11,file=file_current,position='append')
        if(ptime.eq.0.and.id_multi.eq.1.and.iv.eq.1) then
          write(11,'(1x,f12.6,1x,f12.7)') ptime,-aimag(res)
        else
          write(11,'(1x,f12.6,1x,f12.7)')
     &    ptime+(tdmrg(itdmrg)%ts/tdmrg(itdmrg)%is)*(iv-id_multi),
     &    -aimag(res)
        end if
        close(11)
      end if

      deallocate(va)

      return
      end
