      subroutine cvec_rpm(w,vin,vout)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iz,n,n1,n2,ib,i,k,ix1,ix2,ix,mx1,ih
      integer(8) :: imem
      real(8) :: w(ddmrg(1)%nw),wp,an,cn,dn,en,pan,san,sigma2,ax(2),wx
#ifdef cmplx_v
      complex(8) :: zwp
#endif
      real(8),allocatable :: p(:,:)  !1:ddmrg(1)%nw -- 1st, 1+ddmrg(1)%nw:2*ddmrg(1)%nw -- 2nd
      type(avec) :: vin(isbk1:iebk1),vout(isbk1:iebk1,2*ddmrg(1)%nw)
      type(avec),allocatable :: pv(:,:),dpv(:,:)

      ih=1

! --- INITIALIZE
      sigma2=(4.d0/dble(mabcv))**2
      ax=(/pi,two/)
      mx1=nfrx(1)*nfrx(2)*(iebk1-isbk1+1)
      allocate(pv(isbk0:iebk0,2),dpv(isbk1:iebk1,2),
     &         p(2*ddmrg(1)%nw,2))
      call lz_acv(pv(isbk0:iebk0,1),isbk0,iebk0,0,imem)
      call lz_acv(pv(isbk0:iebk0,2),isbk0,iebk0,0,imem)
      call lz_acv(dpv(isbk1:iebk1,1),isbk1,iebk1,1,imem)
      call lz_acv(dpv(isbk1:iebk1,2),isbk1,iebk1,0,imem)

! --- 0th order
! ----- COEFICIENT
!$OMP PARALLEL
!$OMP WORKSHARE
      p(1:ddmrg(1)%nw,1)=1.d0
!$OMP END WORKSHARE NOWAIT
!$OMP DO
      do iz=1,ddmrg(1)%nw
        p(ddmrg(1)%nw+iz,1)=0.5d0*log((1.d0+w(iz))/(1.d0-w(iz)))
      enddo
!$OMP END DO
!$OMP END PARALLEL
! ----- POLYNOMIAL
      call vcopy(vin,pv(isbk1:iebk1,1))
      call rpm_bcast(pv(isbk0:iebk0,1))
!$OMP PARALLEL DO PRIVATE(wx)
      do iz=1,2*ddmrg(1)%nw
        wx=0.5d0*ax(1+(iz-1)/ddmrg(1)%nw)*p(iz,1)
        do ib=isbk1,iebk1
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
                do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
                  vout(ib,iz)%ap(ad(i,k))%b(ix1,ix2)
     &             =wx*pv(ib,1)%ap(ad(i,k))%b(ix1,ix2)
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo

! --- 1st order
      wx=-pwt*psf
! ----- COEFFICIENT
!$OMP PARALLEL
!$OMP WORKSHARE
      p(1:ddmrg(1)%nw,2)=w(1:ddmrg(1)%nw)
!$OMP END WORKSHARE NOWAIT
!$OMP DO
      do iz=1,ddmrg(1)%nw
        p(ddmrg(1)%nw+iz,2)
     &      =one*(0.5d0*w(iz)*log((1.d0+w(iz))/(1.d0-w(iz)))-1.d0)
      enddo
!$OMP END DO NOWAIT
! ----- POLYNOMIAL
!$OMP DO PRIVATE(ib,i,k)
      do ix=1,mx1
        ib=(ix-1)/(nfrx(1)*nfrx(2))+isbk1
        i=mod((ix-1)/nfrx(2),nfrx(1))+1
        k=mod(ix-1,nfrx(2))+1
        do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
          do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
            pv(ib,2)%ap(ad(i,k))%b(ix1,ix2)
     &        =wx*pv(ib,1)%ap(ad(i,k))%b(ix1,ix2)
          enddo
        enddo
      enddo
!$OMP END DO
!$OMP END PARALLEL
      call vcopy(vin,dpv(isbk1:iebk1,2))

      call rpm_bcast(pv(isbk0:iebk0,2))

      call matrix_vec(1,pv(:,1),pv(:,2),pwt*one)

      do iz=1,2*ddmrg(1)%nw
#ifdef cmplx_v
        zwp=cmplx(1.5d0*ax(1+(iz-1)/ddmrg(1)%nw)*p(iz,2),0.d0,kind=8)
        call vaxpy(pv(isbk1:iebk1,2),vout(isbk1:iebk1,iz),zwp)
#else
        wx=1.5d0*ax(1+(iz-1)/ddmrg(1)%nw)*p(iz,2)
        call vaxpy(pv(isbk1:iebk1,2),vout(isbk1:iebk1,iz),wx)
#endif
      enddo

! --- HIGHER ORDER
      do n=2,mabcv
        call rpm_coeff(n,sigma2,pwt,psf,n1,n2,wp,an,cn,dn,en,pan,san)

! ----- COEFFICIENT
!$OMP PARALLEL
!$OMP DO
        do iz=1,ddmrg(1)%nw
          p(iz,n2)=an*w(iz)*p(iz,n1)+cn*p(iz,n2)
        enddo
!$OMP END DO NOWAIT
!$OMP DO
        do iz=ddmrg(1)%nw+1,2*ddmrg(1)%nw
          p(iz,n2)=an*w(iz-ddmrg(1)%nw)*p(iz,n1)+cn*p(iz,n2)
        enddo
!$OMP END DO NOWAIT
! ----- POLYNOMIAL
!$OMP DO PRIVATE(ib,i,k)
        do ix=1,mx1
          ib=(ix-1)/(nfrx(1)*nfrx(2))+isbk1
          i=mod((ix-1)/nfrx(2),nfrx(1))+1
          k=mod(ix-1,nfrx(2))+1
          do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
            do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
              pv(ib,n2)%ap(ad(i,k))%b(ix1,ix2)
     &          =cn*pv(ib,n2)%ap(ad(i,k))%b(ix1,ix2)
     &            +dn*dpv(ib,n1)%ap(ad(i,k))%b(ix1,ix2)
     &            +san*pv(ib,n1)%ap(ad(i,k))%b(ix1,ix2)
            enddo
          enddo
        enddo
!$OMP END DO
!$OMP END PARALLEL
#ifdef cmplx_v
        call vaxpy(pv(isbk1:iebk1,n1),dpv(isbk1:iebk1,n2),
     &             cmplx(en,0.d0,kind=8))
#else
        call vaxpy(pv(isbk1:iebk1,n1),dpv(isbk1:iebk1,n2),en)
#endif
        call rpm_bcast(pv(isbk0:iebk0,n2))

        call matrix_vec(1,pv(:,n1),pv(:,n2),pan*one)

        do iz=1,2*ddmrg(1)%nw
#ifdef cmplx_v
          zwp=cmplx(wp*ax(1+(iz-1)/ddmrg(1)%nw)*p(iz,n2),0.d0,kind=8)
          call vaxpy(pv(isbk1:iebk1,n2),vout(isbk1:iebk1,iz),zwp)
#else
          wx=wp*ax(1+(iz-1)/ddmrg(1)%nw)*p(iz,n2)
          call vaxpy(pv(isbk1:iebk1,n2),vout(isbk1:iebk1,iz),wx)
#endif
        enddo

      enddo !END OF SUM.

      deallocate(p,pv,dpv)

      return
      end
