      subroutine ddmrg_target()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv,i,ix,idx(2)
      real(8) :: x0,x1,x2
      real(8),allocatable :: w(:)

      if(isweep.gt.ddmrg(1)%nsg-1) then
! ----- SET PARAMETERS OF POLYNOMIAL EXPANSION
        call rpm_parameters()

! ----- OPERATE OPERATOR TO INITIAL STATE
        call op_wf(1,2,3)

! ----- COMFIMATION OF NORM OF OPERATED STATES
        if(id_fc.eq.1) then !if id_fc == 1: A(q) - <A(q)>
          call ipv(v(isbk1:iebk1,1),v(isbk1:iebk1,2),isbk1,iebk1,x0)
          call adv(-x0,v(isbk1:iebk1,1),v(isbk1:iebk1,2),isbk1,iebk1)
          call ipv(v(isbk1:iebk1,1),v(isbk1:iebk1,3),isbk1,iebk1,x0)
          call adv(-x0,v(isbk1:iebk1,1),v(isbk1:iebk1,3),isbk1,iebk1)
        end if

        x1=0.d0 !real
        do ix=1,2
          call ipv(v(isbk1:iebk1,ix+1),v(isbk1:iebk1,ix+1),
     &             isbk1,iebk1,x0)
          if(abs(x0).lt.1.d-16) then
            idx(ix)=0
          else
            idx(ix)=1
          end if
          x1=x1+x0
        enddo

        if(myid_dmrg.eq.key_rank) then
          if(ddmrg(1)%nop.eq.1) then
            write(iso,'(2x,a,a,a,a,a,1pe11.4)')
     &      '(expectation value): < ',TRIM(name_op(-ddmrg(1)%iop(1))),
     &      '(q)',TRIM(name_op(ddmrg(1)%iop(1))),'(q) > = ', x1
          else
            write(iso,'(2x,a,1pe11.4)')
     &      '(expectation value): < A†(q)A(q) > = ', x1
          end if
          write(iso,'(2x,a,I0,a,I0)') '(cos term): ',idx(1),
     &                              ', (sin term): ',idx(2)
          write(iso,'(2x,a,I0)') '(KPM truncation number) = ',mabcv
        end if

! ----- MAKING OMEGA FOR RPE
        allocate(w(ddmrg(1)%nw))
        call make_omega(w,ddmrg(1)%nw,ddmrg(1)%wmax,ddmrg(1)%wmin,
     &                  emin,pwt,psf)

! ----- CALCULATING CORRECTION VECTORS
        if(idx(1).eq.1) then
          call cvec_rpm(w,v(:,2),v(:,4:3+2*ddmrg(1)%nw))
        end if
        if(idx(2).eq.1) then
          call cvec_rpm(w,v(:,3),v(:,4+2*ddmrg(1)%nw:3+4*ddmrg(1)%nw))
        end if

! ----- OUTPUT DATA
        call make_omega(w,ddmrg(1)%nw,ddmrg(1)%wmax,ddmrg(1)%wmin,
     &                  0.d0,1.d0,0.d0)

        if(myid_dmrg.eq.key_rank) then
          write(iso,'(1x,a)')
     &     '#   <omega>     < qx >     < qy >     < Re part >
     &      < Im part > '
          if(idmrg.eq.ndmrg) then
            open(51,file=file_dphys_op)
          end if
        end if
        do iv=1,ddmrg(1)%nw
          i=3+iv
          call ipv(v(isbk1:iebk1,2),v(isbk1:iebk1,i),isbk1,iebk1,x1)
          i=3+2*ddmrg(1)%nw+iv
          call ipv(v(isbk1:iebk1,3),v(isbk1:iebk1,i),isbk1,iebk1,x0)
          x1=x1+x0
          i=3+ddmrg(1)%nw+iv
          call ipv(v(isbk1:iebk1,2),v(isbk1:iebk1,i),isbk1,iebk1,x2)
          i=3+3*ddmrg(1)%nw+iv
          call ipv(v(isbk1:iebk1,3),v(isbk1:iebk1,i),isbk1,iebk1,x0)
          x2=x2+x0
          if(myid_dmrg.eq.key_rank) then
            write(iso,'(2x,f10.4,1x,f10.4,1x,f10.4,3x,e14.6,3x,e14.6)')
#ifdef cmplx_v
     &      w(iv),ddmrg(1)%qx,ddmrg(1)%qy,2.d0*x2*pwt,x1*pwt/real(pi)
#else
     &      w(iv),ddmrg(1)%qx,ddmrg(1)%qy,2.d0*x2*pwt,x1*pwt/pi
#endif
            if(idmrg.eq.ndmrg) then
             write(51,'(2x,f10.4,1x,f10.4,1x,f10.4,3x,e14.6,3x,e14.6)')
#ifdef cmplx_v
     &       w(iv),ddmrg(1)%qx,ddmrg(1)%qy,2.d0*x2*pwt,x1*pwt/real(pi)
#else
     &       w(iv),ddmrg(1)%qx,ddmrg(1)%qy,2.d0*x2*pwt,x1*pwt/pi
#endif
            end if
          end if
        enddo

        if(myid_dmrg.eq.key_rank.and.idmrg.eq.ndmrg) then
          close(51)
        end if

        deallocate(w)
      end if

      return
      end
