      subroutine doublon(iv)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv,ix,ista,iend,ip
      complex(8) :: res0,res1,res
      complex(8),allocatable :: res_a0(:)
      type(inop) :: tp(1)
      type(avec),allocatable :: va(:)

      if(myid_dmrg.eq.key_rank.and.np_int.eq.1) then
        write(iso,*)
        write(iso,'(1x,a)') '# doublon'
      end if

! --- INITIALIZE
      allocate(va(isbk0:iebk0))
      call phys_int(iv,va)
      call para_range(1,nsite,np_int,myid_int,ista,iend)
      allocate(res_a0(ista:iend))

! --- CALCULATING PHYSICAL QUANTITIES
      allocate(tp(1)%ni(4),tp(1)%ki(4))
      res1=zero
      tp(1)%mi=4 !number of operator
      tp(1)%fi=1 !1:add to res0
      do ix=ista,iend
        tp(1)%ni(1:4)=ix !site number
        tp(1)%ki=(/1,-1,2,-2/) !operator number
        call phys_cal(va,tp(1),1,res0)

        res_a0(ix)=res0
        if(myid_dmrg.eq.key_rank.and.np_int.eq.1) then
          write(iso,'(2x,I4,7x,f12.7)')
     &      tp(1)%ni(1),real(res0)
        end if

        res1=res1+res0
      enddo

      call mpi_allreduce(res1,res,1,mpi_kv,mpi_sum,newcomm_int,ierr)
      res=res/dble(nsite)

! --- OUTPUT
      if(np_int.gt.1) then
        if(myid_tm.eq.0) then
          if(myid_int.eq.0) then
            write(iso,*)
            do ix=ista,iend
              write(iso,'(2x,I4,1x,f12.7)') ix,real(res_a0(ix))
            enddo
          end if
          allocate(mpist(MPI_STATUS_SIZE))
          do ip=2,np_int
            if(ip-1.eq.myid_int) then
              call mpi_send(ista,1,mpi_integer,0,ip,newcomm_int,ierr)
              call mpi_send(iend,1,mpi_integer,0,ip*10,newcomm_int,ierr)
              call mpi_send(res_a0,iend-ista+1,mpi_kv,0,ip*20,
     &                      newcomm_int,ierr)
            elseif(myid_int.eq.0) then
              call mpi_recv(ista,1,mpi_integer,ip-1,ip,newcomm_int,
     &                      mpist,ierr)
              call mpi_recv(iend,1,mpi_integer,ip-1,ip*10,newcomm_int,
     &                      mpist,ierr)
              deallocate(res_a0)
              allocate(res_a0(ista:iend))
              call mpi_recv(res_a0,iend-ista+1,mpi_kv,ip-1,ip*20,
     &                      newcomm_int,mpist,ierr)
              do ix=ista,iend
                write(iso,'(2x,I4,1x,f12.7)') ix,real(res_a0(ix))
              enddo
            end if
          enddo
          deallocate(mpist)
        end if
      end if

      deallocate(res_a0)

      if(myid_dmrg.eq.key_rank) then
        write(iso,'(2x,a,f12.7)') '(doublon): ',real(res)
        open(11,file=file_doublon,position='append')
        if(ptime.eq.0.d0.and.id_multi.eq.1.and.iv.eq.1) then
          write(11,'(1x,f12.6,1x,f12.7)') ptime,real(res)
        else
          write(11,'(1x,f12.6,1x,f12.7)')
     &    ptime+(tdmrg(itdmrg)%ts/tdmrg(itdmrg)%is)*(iv-id_multi),
     &    real(res)
        end if
        close(11)
      end if

      deallocate(va)

      return
      end
