      subroutine eigen_calculate(m,ib,uvi,es,tb,ill)
      use mod_dmrg
#ifdef EigenExa
      use eigen_libs
#endif
      implicit none
      include 'mpif.h'
      integer :: m,ib,lwk,liwk,ix1,ix2,ill
#ifdef cmplx_v
      integer :: lrw
      complex(8) ::
#else
      real(8) ::
#endif
     &  uvi(ircnt2(myid_(2)+1,ib),ircnt1(myid_(1)+1,ib))
      real(8) :: es(m)
#ifdef cmplx_v
      real(8),allocatable :: rwk(:),uvr(:,:)
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: xb(:),wk(:),uv0(:),uv1(:,:),uvs(:,:)
#ifdef sclpk
      integer :: desca(9),descz(9),
     &           nqz0,nqz,npz,np0,nmz,nmw,mxb,mpz0,lwstedc,lwsytrd,
     &           lwmtr,larray,izrow2,izrow,izcol2,izcol,iarow,
     &           INDXG2P,NUMROC
#ifdef cmplx_v
      integer :: lwhetrd
#endif
#endif
      integer,allocatable :: iwk(:)
      integer,parameter :: id_diago=0
      type(blocks) :: tb

#ifdef sclpk
c----- ScaLapack (PDSYEVD)
      if(m.ge.2000) then
c----- blacs/pblas/scalapack initialization
#ifdef EigenExa
#ifdef cmplx_v
        nmz=(m-1)/nprow+1
        nmw=(m-1)/npcol+1
#else
        call eigen_get_matdims(m,nmz,nmw)
#endif
#else
        nmz=(m-1)/nprow+1
        nmw=(m-1)/npcol+1
#endif
        larray=nmz*nmw

        mxb=1 !Set blocking size

c---- ScaLapack environment initialization
        call descinit(desca,m,m,mxb,mxb,0,0,ictxt,nmz,ill)
        call descinit(descz,m,m,mxb,mxb,0,0,ictxt,nmz,ill)

c---- Set element for matrix
        allocate(xb(larray))
#ifdef EigenExa
!$OMP PARALLEL WORKSHARE
        xb=zero
!$OMP END PARALLEL WORKSHARE
#endif
        call matrix_adjust_s(m,uvi,ib,xb,tb,nmz)

c---- Execute Eigen_library
        iarow=INDXG2P(1,desca(5),myrow,desca(7),nprow)
        np0=NUMROC(m,desca(6),myrow,iarow,nprow)
        izrow2=INDXG2P(1,descz(5),myrow,descz(7),nprow)
        izcol2=INDXG2P(1,descz(6),mycol,descz(8),npcol)
        mpz0=NUMROC(m,descz(5),izrow2,izrow2,nprow)
        nqz0=NUMROC(m,descz(6),izcol2,izcol2,npcol)

        izrow=INDXG2P(1,descz(5),myrow,descz(7),nprow)
        izcol=INDXG2P(1,descz(6),mycol,descz(7),npcol)
        npz=NUMROC(m,descz(5),myrow,izrow,nprow)
        nqz=NUMROC(m,descz(6),mycol,izcol,npcol)

        lwmtr=max((desca(6)*(desca(6)-1))/2,
     &            (mpz0+nqz0)*desca(6))+desca(6)*desca(6)

        liwk=7*m+8*npcol+2

#ifdef cmplx_v
        lwhetrd=max(desca(6)*(np0+1),3*desca(6))

        lwk=m+max(lwhetrd,lwmtr)
        lrw=1+2*m+7*m+3*npz*nqz

        allocate(wk(lwk),rwk(lrw),iwk(liwk),uv0(larray))
        call PZHEEVD('V','U',m,xb,1,1,desca,es,uv0,1,1,descz,wk,lwk,
     &               rwk,lrw,iwk,liwk,ill)
        deallocate(xb,wk,rwk,iwk)

#else
        lwstedc=1+6*m+2*max(1,npz)*nqz
        lwsytrd=3*m+max(desca(6)*(np0+1),3*desca(6))

        lwk=2*m+max(lwstedc,lwsytrd,lwmtr)

c        time_test(1)=mpi_wtime() !test
        allocate(uv0(larray))
#ifdef EigenExa
        call eigen_sx(m,m,xb,nmz,es,uv0,nmz)
#else
        allocate(wk(lwk),iwk(liwk))
        call PDSYEVD('V','U',m,xb,1,1,desca,es,uv0,1,1,descz,wk,lwk,
     &               iwk,liwk,ill)
        deallocate(wk,iwk)
#endif
c        time_test(2)=time_test(2)+(mpi_wtime()-time_test(1)) !test

        deallocate(xb)
#endif
c---- Change element position for matrix
        call matrix_adjust2_s(uvi,ib,uv0,nmz)

      else
#endif
c----- Lapack
        allocate(uv1(tb%size0(ib),ircnt1(myid_(1)+1,ib)))
        call gc2d(uvi,ircnt2(myid_(2)+1,ib),ircnt1(myid_(1)+1,ib),
     &            uv1,tb%size0(ib),np_(2),newcomm_(2))
        allocate(uvs(m,m))
        call gr2d(uv1,tb%size0(ib)*ircnt1(myid_(1)+1,ib),
     &            uvs,np_(1),newcomm_(1))
        deallocate(uv1)

#ifdef cmplx_v
        if(id_diago.eq.1) then
          lwk=(m+2)*m
          allocate(wk(lwk),rwk(3*m-2))
          call ZHEEV('V','U',m,uvs,m,es,wk,lwk,rwk,ill)
          deallocate(wk,rwk)
        elseif(id_diago.eq.0) then
          lwk=2*m+m*m; lrw=1+5*m+2*m*m; liwk=3+5*m
          allocate(wk(lwk),rwk(lrw),iwk(liwk))
          call ZHEEVD('V','U',m,uvs,m,es,wk,lwk,rwk,lrw,iwk,liwk,ill)
          deallocate(wk,rwk,iwk)
        else
          allocate(uvr(m,m))
          do ix1=1,m
            do ix2=1,m
              uvr(ix2,ix1)=real(uvs(ix2,ix1))
            enddo
          enddo
          lwk=1+6*m+2*m*m; liwk=3+5*m
          allocate(rwk(lwk),iwk(liwk))
          call DSYEVD('V','U',m,uvr,m,es,rwk,lwk,iwk,liwk,ill)
          deallocate(rwk,iwk)
          do ix1=1,m
            do ix2=1,m
              uvs(ix2,ix1)=cmplx(uvr(ix2,ix1),0.d0,kind=8)
            enddo
          enddo
          deallocate(uvr)
        end if
#else
        if(id_diago.eq.1) then
          lwk=(2+m)*m
          allocate(wk(lwk))
          call DSYEV('V','U',m,uvs,m,es,wk,lwk,ill)
          deallocate(wk)
        else
          lwk=1+6*m+2*m*m; liwk=3+5*m
          allocate(wk(lwk),iwk(liwk))
          call DSYEVD('V','U',m,uvs,m,es,wk,lwk,iwk,liwk,ill)
          deallocate(wk,iwk)
        end if
#endif

! ----- DATA SYNCHRONIZATION
!!!        if(myid_(2).eq.0) then
!!!          call mpi_bcast(uvs,m*m,mpi_kv,0,newcomm_(1),ierr)
!!!          call mpi_bcast(es,m,mpi_kv,0,newcomm_(1),ierr)
!!!        end if
!!!        if(m*ircnt1(myid_(1)+1,ib).gt.0) then
!!!          call mpi_bcast(uvs(:,idisp1(myid_(1)+1,ib)+1),
!!!     &                   m*ircnt1(myid_(1)+1,ib),mpi_kv,0,
!!!     &                   newcomm_(2),ierr)
!!!        end if
!!!        call mpi_bcast(es,m,MPI_REAL8,0,newcomm_(2),ierr)

!$OMP PARALLEL DO
        do ix2=1,ircnt1(myid_(1)+1,ib)
          do ix1=1,ircnt2(myid_(2)+1,ib)
            uvi(ix1,ix2)=uvs(idisp2(myid_(2)+1,ib)+ix1,
     &                       idisp1(myid_(1)+1,ib)+ix2)
          enddo
        enddo
        deallocate(uvs)
#ifdef sclpk
      endif
#endif

      return
      end
