      subroutine gc2d(vin,lc,lr,vout,mc,np,ncm)
      implicit none
      include 'mpif.h'
      integer :: lc,lr,mc,np,ncm,ierr,ix,ix1,ix2,ix3,ir
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  vin(lc,lr),vout(mc,lr)
      integer,allocatable :: ircnt(:),idisp(:)
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: vc(:)

      allocate(ircnt(np),idisp(np),vc(mc*lr))

      call pre_algv(lc*lr,np,ncm,ircnt,idisp)

#ifdef cmplx_v
      call mpi_allgatherv(vin,lc*lr,mpi_double_complex,vc,ircnt,idisp,
     &                    mpi_double_complex,ncm,ierr)
#else
      call mpi_allgatherv(vin,lc*lr,MPI_REAL8,vc,ircnt,idisp,MPI_REAL8,
     &                    ncm,ierr)
#endif

      call pre_algv(lc,np,ncm,ircnt,idisp)

!$OMP PARALLEL DO PRIVATE(ir,ix2,ix3)
      do ix=0,lr*np-1
        ir=mod(ix,np)+1
        ix2=ix/np+1
        ix3=idisp(ir)*lr+ircnt(ir)*(ix2-1)
        do ix1=1,ircnt(ir)
          vout(ix1+idisp(ir),ix2)=vc(ix1+ix3)
        enddo
      enddo

      deallocate(ircnt,idisp,vc)

      return
      end

************************************************************************
      subroutine gc2ds(vin,lc,lr,vout,mc,np,mi,iroot,ncm)
      implicit none
      include 'mpif.h'
      integer :: lc,lr,mc,np,mi,iroot,ncm,ierr,ix,ix1,ix2,ix3,ir
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  vin(lc,lr),vout(mc,lr)
      integer,allocatable :: ircnt(:),idisp(:)
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: vc(:)

      allocate(ircnt(np),idisp(np),vc(mc*lr))

      call pre_algv(lc*lr,np,ncm,ircnt,idisp)

#ifdef cmplx_v
      call mpi_gatherv(vin,lc*lr,mpi_double_complex,vc,ircnt,idisp,
     &                 mpi_double_complex,iroot,ncm,ierr)
#else
      call mpi_gatherv(vin,lc*lr,MPI_REAL8,vc,ircnt,idisp,MPI_REAL8,
     &                 iroot,ncm,ierr)
#endif

      call pre_algv(lc,np,ncm,ircnt,idisp)

      if(mi.eq.iroot) then
!$OMP PARALLEL DO PRIVATE(ir,ix2,ix3)
        do ix=0,lr*np-1
          ir=mod(ix,np)+1
          ix2=ix/np+1
          ix3=idisp(ir)*lr+ircnt(ir)*(ix2-1)
          do ix1=1,ircnt(ir)
            vout(ix1+idisp(ir),ix2)=vc(ix1+ix3)
          enddo
        enddo
      end if

      deallocate(ircnt,idisp,vc)

      return
      end
