      subroutine init_mpi_bk(id)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,ib
      integer,allocatable :: kidx(:)

! --- INITIALIZATION
      if(id.eq.1) then
        deallocate(kid0,kid1)
      end if

! --- INITIALIZE PARALLELIZATION BETWEEN BLOCKS
      if(id.eq.1.or.(nas*nae.eq.0.and.if_tdmrg.eq.0)) then
        call para_range(1,nbk,np_bk,myid_bk,isbk0,iebk0)
      else
        call parac_block(1,nbk,isbk0,iebk0,np_bk,myid_bk,newcomm_bk)
      end if

      if(myid_mx.eq.0) then
        allocate(kid0(nbk),kidx(nbk))
!$OMP PARALLEL DO
        do ib=1,isbk0-1
          kidx(ib)=0
        enddo
!$OMP PARALLEL DO
        do ib=isbk0,iebk0
          kidx(ib)=myid_bk
        enddo
!$OMP PARALLEL DO
        do ib=iebk0+1,nbk
          kidx(ib)=0
        enddo
        call mpi_allreduce(kidx,kid0,nbk,mpi_integer,mpi_sum,
     &                     newcomm_bk,ierr)
        deallocate(kidx)
      else
        allocate(kid0(nbk))
!$OMP PARALLEL WORKSHARE
        kid0=0
!$OMP END PARALLEL WORKSHARE
      end if
      call mpi_bcast(kid0,nbk,mpi_integer,0,newcomm_mx,ierr)

! --- isbk1,iebk1
      if(id.eq.1.or.nas*nae.eq.0) then
        call para_range(isbk0,iebk0,np_int,myid_int,isbk1,iebk1)
      else
        call parac_block(isbk0,iebk0,isbk1,iebk1,np_int,myid_int,
     &                   newcomm_int)
      end if

      allocate(kid1(isbk0:iebk0),kidx(isbk0:iebk0))
!$OMP PARALLEL WORKSHARE
      kidx=0
!$OMP END PARALLEL WORKSHARE
      do ib=isbk1,iebk1
        kidx(ib)=myid_int
      enddo
      call mpi_allreduce(kidx,kid1,iebk0-isbk0+1,mpi_integer,mpi_sum,
     &                   newcomm_int,ierr)
      deallocate(kidx)

! --- isbk2,iebk2
      call para_range(isbk1,iebk1,np_add,myid_add,isbk2,iebk2)

! --- isbk3,iebk3
      call para_range(isbk1,iebk1,np_mx,myid_mx,isbk3,iebk3)

! --- isbk4,iebk4
      call para_range(isbk2,iebk2,np_mx,myid_mx,isbk4,iebk4)

      return
      end
