      subroutine init_operators()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,ib,ib1,ib2,it,ih,mhx,i
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &    fg

      if(id_space.eq.0) then
        nbk=1
      else
        nbk=nfr
      end if
      allocate(block(2,nsite,nh))

      do mhx=1,nh
        block(1:2,1,mhx)%nbk=nbk   !number of block
        block(1:2,1,mhx)%ndmx=nfr  !dimension of block

        do ise=1,2   ! 1:system, 2:environment
!!!!! BLOCK INFOMATION
          allocate(block(ise,1,mhx)%nud(nfr,2),
     &             block(ise,1,mhx)%size(nbk),
     &             block(ise,1,mhx)%size0(nbk),
     &             block(ise,1,mhx)%sizex(nbk,nfr),
     &             block(ise,1,mhx)%stax(nbk,nfr),
     &             block(ise,1,mhx)%b2b(nbk,-1:1,nop),
     &             block(ise,1,mhx)%kid(nbk),
     &             block(ise,1,mhx)%ista0(nbk,2),
     &             block(ise,1,mhx)%iend0(nbk,2),
     &             block(ise,1,mhx)%isize0(nbk,2),
     &             block(ise,1,mhx)%ista(nbk,2),
     &             block(ise,1,mhx)%iend(nbk,2),
     &             block(ise,1,mhx)%isize(nbk,2))

          block(ise,1,mhx)%sizex=0
          block(ise,1,mhx)%kid=0

          if(id_space.eq.1) then
            block(ise,1,mhx)%stax=1
            block(ise,1,mhx)%nud=iud
            block(ise,1,mhx)%b2b=0
            do ib=1,nbk
              block(ise,1,mhx)%size(ib)=1
              block(ise,1,mhx)%size0(ib)=1
              block(ise,1,mhx)%sizex(ib,ib)=1
              block(ise,1,mhx)%b2b(ib,0,1:nop)=ib
            enddo

            do ib1=1,nbk
              do ib2=1,nbk
                do it=1,nop
                  if(block(ise,1,mhx)%nud(ib1,1)-nch(1,it).eq.
     &               block(ise,1,mhx)%nud(ib2,1).and.
     &               block(ise,1,mhx)%nud(ib1,2)-nch(2,it).eq.
     &               block(ise,1,mhx)%nud(ib2,2)) then
                    block(ise,1,mhx)%b2b(ib1,1,it)=ib2
                  end if
                  if(block(ise,1,mhx)%nud(ib1,1)+nch(1,it).eq.
     &               block(ise,1,mhx)%nud(ib2,1).and.
     &               block(ise,1,mhx)%nud(ib1,2)+nch(2,it).eq.
     &               block(ise,1,mhx)%nud(ib2,2)) then
                    block(ise,1,mhx)%b2b(ib1,-1,it)=ib2
                  end if
                enddo
              enddo
            enddo
          else
            do ib=1,nfr
              block(ise,1,mhx)%stax(1,ib)=ib
            enddo
            block(ise,1,mhx)%nud=0
            block(ise,1,mhx)%b2b=1
            block(ise,1,mhx)%size(1)=nfr
            block(ise,1,mhx)%size0(1)=nfr
            block(ise,1,mhx)%sizex(1,1:nfr)=1
          end if

c --- HAMILTONIAN OF INITIAL BLOCKS
          allocate(block(ise,1,mhx)%b(nbk))

c ----- HAMILTONIAN
          do ib=1,nbk
            if(id_space.eq.1) then
              allocate(block(ise,1,mhx)%b(ib)%hm(1,1))
              mem_hm=mem_hm+8
            else
              allocate(block(ise,1,mhx)%b(ib)%hm(nfr,nfr))
              mem_hm=mem_hm+8*nfr*nfr
            end if
            block(ise,1,mhx)%b(ib)%hm=zero
          enddo

          if(id_hop.eq.1) then !hopping term (electron model)
            if(id_space.eq.1) then
!$OMP PARALLEL DO
              do ib=1,nbk
                allocate(block(ise,1,mhx)%b(ib)%hmt(1,1,2))
                block(ise,1,mhx)%b(ib)%hmt=zero
              enddo
              mem_hm=mem_hm+2*8*nbk
            else
              allocate(block(ise,1,mhx)%b(1)%hmt(nfr,nfr,2))
!$OMP PARALLEL WORKSHARE
              block(ise,1,mhx)%b(1)%hmt=zero
!$OMP END PARALLEL WORKSHARE
              mem_hm=mem_hm+2*8*nfr*nfr
            end if
          end if

!$OMP PARALLEL DO
          do ih=1,nh2+nh4 !(electron model)
            if(hamil(ih)%nop.eq.2.and.id_spin.eq.0) then
              if(ise.eq.1) then
                if(hamil(ih)%ihs(1).eq.1.and.
     &             hamil(ih)%ihs(2).eq.1) then !potential term
                  if(id_space.eq.0) then
                    block(ise,1,mhx)%b(1)%hm(2,2)
     &                =block(ise,1,mhx)%b(1)%hm(2,2)
     &                  +hamil(ih)%vh(ihcf(nit+1))
                    if(id_spinless.eq.0) then
                      block(ise,1,mhx)%b(1)%hm(3,3)
     &                  =block(ise,1,mhx)%b(1)%hm(3,3)
     &                    +hamil(ih)%vh(ihcf(nit+1))
                      block(ise,1,mhx)%b(1)%hm(4,4)
     &                  =block(ise,1,mhx)%b(1)%hm(4,4)
     &                    +two*hamil(ih)%vh(ihcf(nit+1)) !two electron
                    end if
                  else
                    block(ise,1,mhx)%b(2)%hm(1,1)
     &                =block(ise,1,mhx)%b(2)%hm(1,1)
     &                  +hamil(ih)%vh(ihcf(nit+1))
                    if(id_spinless.eq.0) then
                      block(ise,1,mhx)%b(3)%hm(1,1)
     &                  =block(ise,1,mhx)%b(3)%hm(1,1)
     &                    +hamil(ih)%vh(ihcf(nit+1))
                      block(ise,1,mhx)%b(4)%hm(1,1)
     &                  =block(ise,1,mhx)%b(4)%hm(1,1)
     &                    +two*hamil(ih)%vh(ihcf(nit+1)) !two electron
                    end if
                  end if
                end if
              elseif(ise.eq.2) then
                if(hamil(ih)%ihs(1).eq.nsite.and.
     &             hamil(ih)%ihs(2).eq.nsite) then !potential term
                  if(id_space.eq.0) then
                    block(ise,1,mhx)%b(1)%hm(2,2)
     &                =block(ise,1,mhx)%b(1)%hm(2,2)
     &                  +hamil(ih)%vh(ihcf(nit+1))
                    if(id_spinless.eq.0) then
                      block(ise,1,mhx)%b(1)%hm(3,3)
     &                  =block(ise,1,mhx)%b(1)%hm(3,3)
     &                     +hamil(ih)%vh(ihcf(nit+1))
                      block(ise,1,mhx)%b(1)%hm(4,4)
     &                  =block(ise,1,mhx)%b(1)%hm(4,4)
     &                    +two*hamil(ih)%vh(ihcf(nit+1))
                    end if
                  else
                    block(ise,1,mhx)%b(2)%hm(1,1)
     &                =block(ise,1,mhx)%b(2)%hm(1,1)
     &                  +hamil(ih)%vh(ihcf(nit+1))
                    if(id_spinless.eq.0) then
                      block(ise,1,mhx)%b(3)%hm(1,1)
     &                  =block(ise,1,mhx)%b(3)%hm(1,1)
     &                     +hamil(ih)%vh(ihcf(nit+1))
                      block(ise,1,mhx)%b(4)%hm(1,1)
     &                  =block(ise,1,mhx)%b(4)%hm(1,1)
     &                    +two*hamil(ih)%vh(ihcf(nit+1))
                    end if
                  end if
                end if
              end if
            elseif(hamil(ih)%nop.eq.4.and.id_spin.eq.0) then
              if(ise.eq.1) then
                if(hamil(ih)%ihs(1).eq.1.and.
     &             hamil(ih)%ihs(2).eq.1.and.
     &             hamil(ih)%ihs(3).eq.1.and.
     &             hamil(ih)%ihs(4).eq.1) then !on-site Coulomb
                  if(id_space.eq.0) then
                    block(ise,1,mhx)%b(1)%hm(4,4)
     &                =block(ise,1,mhx)%b(1)%hm(4,4)
     &                   +hamil(ih)%vh(ihcf(nit+1))
                  else
                    block(ise,1,mhx)%b(4)%hm(1,1)
     &                =block(ise,1,mhx)%b(4)%hm(1,1)
     &                   +hamil(ih)%vh(ihcf(nit+1))
                  end if
                end if
              elseif(ise.eq.2) then
                if(hamil(ih)%ihs(1).eq.nsite.and.
     &             hamil(ih)%ihs(2).eq.nsite.and.
     &             hamil(ih)%ihs(3).eq.nsite.and.
     &             hamil(ih)%ihs(4).eq.nsite) then !on-site Coulomb
                  if(id_space.eq.0) then
                    block(ise,1,mhx)%b(1)%hm(4,4)
     &                =block(ise,1,mhx)%b(1)%hm(4,4)
     &                   +hamil(ih)%vh(ihcf(nit+1))
                  else
                    block(ise,1,mhx)%b(4)%hm(1,1)
     &                =block(ise,1,mhx)%b(4)%hm(1,1)
     &                   +hamil(ih)%vh(ihcf(nit+1))
                  end if
                end if
              end if
            end if
          enddo

! --- MAGNETIC FIELD
          if(allocated(fmag)) then !magnetic field
            if(ise.eq.1) then
              i=1
            else
              i=nsite
            end if

! ----- LIMITED SPIN-SPACE
            if(id_space.eq.1) then !limited spin-space
              if(abs(fmag(3,i)).gt.dlim_int) then !z-direction
!$OMP PARALLEL DO
                do ib=1,nbk
                  block(ise,1,mhx)%b(ib)%hm(1,1)
     &              =block(ise,1,mhx)%b(ib)%hm(1,1)
#ifdef cmplx_v
     &
     &          +cmplx(-fmag(3,i)*dble(iud(ib,1)-iud(ib,2))*cmag(3),
     &                 0.d0,kind=8)
#else
     &                 -fmag(3,i)*dble(iud(ib,1)-iud(ib,2))*cmag(3)
#endif
                enddo
              end if

! ----- UNLIMITED SPIN-SPACE
            else !unlimited spin-space
              if(abs(fmag(1,i)).gt.dlim_int) then !x-direction
#ifdef cmplx_v
                fg=cmplx(-fmag(1,i)*cmag(1),0.d0,kind=8)
#else
                fg=-fmag(1,i)*cmag(1)
#endif
!$OMP PARALLEL DO
                do ib=1,nfr-1
                  block(ise,1,mhx)%b(1)%hm(ib+1,ib)
     &              =block(ise,1,mhx)%b(1)%hm(ib+1,ib)+fg
                  block(ise,1,mhx)%b(1)%hm(ib,ib+1)
     &              =block(ise,1,mhx)%b(1)%hm(ib,ib+1)+fg
                enddo
              end if

#ifdef cmplx_v
              if(abs(fmag(2,i)).gt.dlim_int) then !y-direction
                if(ise.eq.1) then
                  fg=cmplx(0.d0,fmag(2,i)*cmag(2),kind=8)
                elseif(ise.eq.2) then
                  fg=cmplx(0.d0,-fmag(2,i)*cmag(2),kind=8)
                end if
!$OMP PARALLEL DO
                do ib=1,nfr-1
                  block(ise,1,mhx)%b(1)%hm(ib+1,ib)
     &              =block(ise,1,mhx)%b(1)%hm(ib+1,ib)+fg
                  block(ise,1,mhx)%b(1)%hm(ib,ib+1)
     &              =block(ise,1,mhx)%b(1)%hm(ib,ib+1)-fg
                enddo
              end if
#endif

              if(abs(fmag(3,i)).gt.dlim_int) then !z-direction
!$OMP PARALLEL DO
                do ib=1,nfr
                  block(ise,1,mhx)%b(1)%hm(ib,ib)
     &              =block(ise,1,mhx)%b(1)%hm(ib,ib)
#ifdef cmplx_v
     &       +cmplx(-fmag(3,i)*dble(iud(ib,1)-iud(ib,2))*cmag(3),
     &              0.d0,kind=8)
#else
     &              -fmag(3,i)*dble(iud(ib,1)-iud(ib,2))*cmag(3)
#endif
                enddo
              end if
            end if
          end if

        enddo
      enddo

      return
      end
