      program main
      use mod_dmrg_input
!$    use omp_lib
      implicit none
      include 'mpif.h'
      integer :: myid,nproc,ierr,i,loop,nsamp
      integer,parameter :: kind_cal=0
      real(8) :: time_sta,time_end
      character(64) :: para

c --- INITIALIZE
      call mpi_init(ierr)
      call mpi_comm_size(mpi_comm_world,nproc,ierr)
      call mpi_comm_rank(mpi_comm_world,myid,ierr)
      time_sta=mpi_wtime()

      call getarg(1,para)

c --- DMRG
      if(index(para,'-init').ne.0.or.index(para,'-I').ne.0) then !initialize input data
        if(myid.eq.0) then
          call set_input()
        end if

      elseif(index(para,'-ml').eq.1.or.kind_cal.eq.1) then !machine learnning
        call split_comm(mpi_comm_world,myid,nproc,nproc,
     &                  newcomm_dmrg,myid_dmrg,np_dmrg,
     &                  newcomm_dmrg_r,myid_dmrg_r,np_dmrg_r)

c        nsamp=10201 !random_UV(1,i)
c        nsamp=10000 !random_UV(2,i): training data
        nsamp=1000

        allocate(ML_label(1))
        loop=(nsamp-1)/np_dmrg_r+1
        do i=1,loop
          if(myid.eq.0) write(6,'(1x,I0,a,I0)') i,'/',loop
          call random_UV(5,i)
          call dmrg()
        enddo
        deallocate(ML_label)

        if(np_dmrg_r.gt.1) then
          call make_es(nsamp,myid)
        end if

      else !usual DMRG calculation
        call split_comm(mpi_comm_world,myid,nproc,1,
     &                  newcomm_dmrg,myid_dmrg,np_dmrg,
     &                  newcomm_dmrg_r,myid_dmrg_r,np_dmrg_r)
        if(myid.eq.0) then
          write(6,'(1x,a)') '# DDMRG version 2.0.0'
        end if
        loop=1
        do while(loop.gt.0)
          call dmrg()
          loop=0
        enddo
      end if

c -- FINALIZE
      time_end=mpi_wtime()
#ifdef timer
      if(myid_dmrg.eq.0) then
        if(np_dmrg_r.eq.1.or.kind_cal.eq.1) then
          if(kind_cal.ne.1) write(6,*)
          if(myid_dmrg_r.eq.0) then
            write(6,'(2x,a,f15.3,a)')
     &      '(elapsed time):',time_end-time_sta,' [s]'
          end if
        elseif(np_dmrg_r.gt.1) then
          write(6,'(2x,a,I6,a,f15.3,a)')
     &      '(ID):',myid_dmrg_r,
     &      ', (elapsed time):',time_end-time_sta,' [s]'
        end if
      end if
#endif

      call mpi_finalize(ierr)

      stop
      end
