      subroutine make_operators(msi,nsi,ksi,bp,b,fsign0)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      type(bop) :: bp
      integer :: msi,nsi(msi),ksi(msi),ib,jb,ik1,ik2,ix,is,ix1,ix2,ise,
     &           ic,ms,iwt,ip,ip1,ip2,lsta,lend,lsize,ksta,kend
      real(8) :: fsign0,fsign
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  b,fs
      integer,allocatable :: ns(:),ks(:),ls(:),lb(:,:),nov(:),
     &                       ie(:),nstm(:),ietm(:),ies(:),iop(:),kb(:),
     &                       ircntx(:),idispx(:),ircnty(:),idispy(:),
     &                       ircntz(:),idispz(:)
#ifdef cmplx_v
      complex(8),allocatable :: 
#else
      real(8),allocatable :: 
#endif
     &  ops(:,:),vop(:),wk1(:,:),wk2(:,:)

C --- UNIT OPERATOR
      if(msi.eq.0) then
        ise=int(abs(fsign0)+1.d-12)
        if(.not.allocated(bp%bt)) then
          allocate(bp%bt(block(ise,nse(ise),mh)%nbk))
        end if
        do ib=1,block(ise,nse(ise),mh)%nbk
          if(.not.allocated(bp%bt(ib)%op)) then
            allocate(bp%bt(ib)%op(block(ise,nse(ise),mh)%size(ib),
     &                            block(ise,nse(ise),mh)%size(ib)))
            if(fsign0.gt.0.d0) then
!$OMP PARALLEL WORKSHARE
              bp%bt(ib)%op=zero
!$OMP END PARALLEL WORKSHARE
            end if
          end if
          if(fsign0.gt.0.d0) then
!$OMP PARALLEL DO
            do ix1=1,block(ise,nse(ise),mh)%size(ib)
              bp%bt(ib)%op(ix1,ix1)=bp%bt(ib)%op(ix1,ix1)+one
            enddo
          end if
        enddo
        return
      else
        fsign=sign(1.d0,fsign0)
      end if

C --- INITIALIZATION
      if(allocated(iex)) then
        allocate(ie(2),nstm(msi))
        nstm=nsi
        ie=0
      end if

C --- SORTING NUMBERING OF SITES
      if(msi.gt.1) then
        ierr=0
        call sortii(msi,nsi,ksi,ierr)
      end if

C --- COUNTING NUMBER OF RELATING SITES
      ms=1
      do ix=2,msi
        if(nsi(ix-1).ne.nsi(ix)) then
          ms=ms+1
        end if
      enddo

C --- CONFORMING KINDS OF OPERATOR TO SITE NUMBER
      allocate(ns(ms+1),ks(msi),ls(0:ms),lb(ms,nop),ops(nfr,nfr),
     &         iop(nfr),vop(nfr))
      ise=1+int(dble(nsi(1)/(nse(1)+nadd))
     &      /(dble(nsi(1)/(nse(1)+nadd))+1.d-16))
      ls(0)=0
      ls(ms)=msi
      ns(ms+1)=0
      allocate(ietm(msi))
      ietm=0
      if(allocated(iex)) then
        ietm(1:msi)=iex(1:msi,ise)
        ierr=0
        call sortii(msi,nstm,ietm,ierr)
        deallocate(nstm)
      end if
      ms=1
      if(nsi(1).le.nse(1)) then !SYSTEM
        if(allocated(iex)) then
          do ix=1,msi
            iex(ix,ise)=ietm(ix)
          enddo
        end if
        ns(1)=nsi(1)
        do ix=2,msi
          if(nsi(ix-1).ne.nsi(ix)) then
            ls(ms)=ix-1
            ms=ms+1
            ns(ms)=nsi(ix)
          end if
        enddo
        do ix=1,ms
          ks(ls(ix-1)+1:ls(ix))=ksi(ls(ix-1)+1:ls(ix))
        enddo
      else   !ENVIRONMENT
        if(allocated(iex)) then
          do ix=1,msi
            iex(msi-ix+1,ise)=ietm(ix)
          enddo
        end if
        ns(1)=nsite-nsi(msi)+1
        do ix=msi-1,1,-1
          if(nsi(ix+1).ne.nsi(ix)) then
            ls(ms)=msi-ix
            ms=ms+1
            ns(ms)=nsite-nsi(ix)+1
          end if
        enddo
        do ix=1,ms
          ks(ls(ix-1)+1:ls(ix))=ksi(msi-ls(ix)+1:msi-ls(ix-1))
        enddo
      end if
      if(allocated(ietm)) deallocate(ietm)

C ---  CHECKING BLOCK NUMBER GIVEN BY OPERATIONS
!$OMP PARALLEL WORKSHARE
      lb=0
!$OMP END PARALLEL WORKSHARE
      do ic=1,ms
        do ix=1,ls(ic) !start from 1st operator
          lb(ic,abs(ks(ix)))=lb(ic,abs(ks(ix)))
     &      +sign(1,ks(ix))*kch(abs(ks(ix)))
        enddo
      enddo

!!!!! MAKING & TRANSFORMING OF OPERATOR !!!!!
      if(allocated(np)) deallocate(np)
      if(allocated(nov)) deallocate(nov)
      if(allocated(kb)) deallocate(kb)
      allocate(np(2),nov(2),kb(nfr))
      if(.not.allocated(bp%bt)) then
        allocate(bp%bt(block(ise,nse(ise),mh)%nbk))
      end if
      nov=0

!!!!! LOOP START FOR SITES !!!!!
      ic=0
      do is=ns(1),nse(ise) !LOOP START FOR SITES
        if(is.eq.ns(ic+1)) then !OPERATOR AT ADDED SITE
C --- MAKING OPERATOR AT ADDED SITE
          ic=ic+1
!$OMP PARALLEL WORKSHARE
          iop=0; vop=zero
!$OMP END PARALLEL WORKSHARE
          call single_opx(ls(ic)-ls(ic-1),ks(ls(ic-1)+1:ls(ic)),
     &                    iop,vop,one)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#ifdef cmplx_v
          if(ise.eq.2) then
            vop=conjg(vop)
          end if
#endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

C --- CHECKING SPIN INSIDE BLOCK
          if(ic.eq.1) then
            if(allocated(iex)) then
              do ix=ls(ic-1)+1,ls(ic)
                ie(abs(iex(ix,ise)))=ie(abs(iex(ix,ise)))+1
              enddo
            end if
          else
            if(allocated(iex)) then
              allocate(ietm(2),ies(2))
              ietm=ie; ies=0
              do ix=ls(ic-1)+1,ls(ic)
                ie(abs(iex(ix,ise)))=ie(abs(iex(ix,ise)))+1
              enddo
              do ix=ls(ic-1)+1,ls(ic)
                ies(abs(iex(ix,ise)))=abs(ks(ix))
              enddo
              if(ls(ic)-ls(ic-1).eq.2.and.
     &           abs(iex(ls(ic-1)+1,ise)).ne.abs(iex(ls(ic),ise))) then
                do ix=1,2
                  if(ie(ix).ne.ietm(ix)) then
                    nov(ies(ix))=0
                  end if
                enddo
              else
                do ix=1,2
                  if((ie(1).eq.2.and.ie(1).ne.ietm(1)).or.
     &               (ie(2).eq.2.and.ie(2).ne.ietm(2))) then
                    nov(ix)=abs(lb(ic,ix))
                  else
                    nov(ix)=abs(lb(ic-1,ix))
                  end if
                enddo
              end if
              deallocate(ies,ietm)

            else !NUMBER ÒF ELECTRONS OVER ADDED SITE
              if(abs(lb(ic-1,1)).lt.abs(lb(ic,1)).or.
     &           abs(lb(ic-1,2)).lt.abs(lb(ic,2))) then
                nov(1)=abs(lb(ic-1,1))
                nov(2)=abs(lb(ic-1,2))
              else
                nov(1)=abs(lb(ic,1))
                nov(2)=abs(lb(ic,2))
              end if
            end if
          end if
        else !OPERATOR NOT AT ADDED SITE
          vop=one
          do ik1=1,nfr
            iop(ik1)=ik1
          enddo
          nov(1)=abs(lb(ic,1))
          nov(2)=abs(lb(ic,2))
        end if

C --- CONFIMATION 'jb'
        do ib=1,block(ise,is,mh)%nbk
          call ck_block(ib,jb,lb,ms,ic,ise,is)
          if(jb.eq.0) cycle
          if(block(ise,is,mh)%kid(ib).eq.block(ise,is,mh)%kid(jb)) cycle
          call mpi_uv(ise,is,ib,jb)
        enddo

C --- TRANSFORMING BASIS SET
        allocate(np(mod(is,2)+1)%bp(block(ise,is,mh)%nbk,np_env))

        do ib=block(ise,is,mh)%isbk,block(ise,is,mh)%iebk
C ----- CONFIMATION OF BLOCKS
          call ck_block(ib,jb,lb,ms,ic,ise,is)
          if(jb.eq.0) cycle

C ----- MULTIPLICATION ADDED SITE OPERATOR BY BLOCK'S ONE
          if(is.eq.ns(1)) then !1ST MULTIPLICATION OPERATOR (BY UNIT)
            if(allocated(np(mod(is-1,2)+1)%bp)) then
              deallocate(np(mod(is-1,2)+1)%bp)
            end if

            do ik1=1,nfr
              ik2=iop(ik1)
              if(ik2.eq.0) cycle
              kb(ik1)=ik1
            enddo
          else 
            do ik1=1,nfr
              kb(ik1)=block(ise,is,mh)%nse(ib,ik1)*iop(ik1)
              if(iop(ik1).eq.0) cycle
              kb(ik1)=kb(ik1)/iop(ik1)
            enddo
          end if

C ----- TRANSFORMATION OF BASIS SET
          if(is.eq.nse(ise)) then !CASE OF FINAL LOOP FOR SITES
            if(.not.allocated(bp%bt(ib)%op)) then
              allocate(bp%bt(ib)%op(block(ise,nse(ise),mh)%size(jb),
     &                              block(ise,nse(ise),mh)%size(ib)))
              mem_op=mem_op+8*size(bp%bt(ib)%op)
              iwt=0
              if(block(ise,is,mh)%ndmx.le.mts) then
!$OMP PARALLEL WORKSHARE
                bp%bt(ib)%op=zero
!$OMP END PARALLEL WORKSHARE
              end if
            else
              iwt=1
            end if

            if(block(ise,is,mh)%ndmx.gt.mts) then
              call trabset_op(iop,vop,nov,kb,ise,ib,jb,bp,is,iwt,b,
     &                        fsign,1)
            else
              if(is.eq.ns(1)) then
                do ik1=1,nfr
                  ik2=iop(ik1)
                  if(ik2.eq.0) cycle
                  fs=b*vop(ik1)
!$OMP PARALLEL DO
                  do ix=1,block(ise,nse(ise),mh)%sizex(ib,ik1)
                    bp%bt(ib)
     &                %op(block(ise,nse(ise),mh)%stax(jb,ik2)+ix-1,
     &                    block(ise,nse(ise),mh)%stax(ib,ik1)+ix-1)
     &              =bp%bt(ib)
     &                %op(block(ise,nse(ise),mh)%stax(jb,ik2)+ix-1,
     &                    block(ise,nse(ise),mh)%stax(ib,ik1)+ix-1)
     &                +fs
                  enddo
                enddo
              else
                allocate(ircnt(np_sys),idisp(np_sys))
                call para_range(1,block(ise,is,mh)%size(ib),
     &                          np_sys,myid_sys,lsta,lend)
                lsize=lend-lsta+1
                call pre_algv(lsize,np_sys,newcomm_sys,ircnt,idisp)

                allocate(wk1(block(ise,nse(ise),mh)%size(jb),
     &                       lsta:lend))
                if(myid_env.eq.0) then
                  call XCOPY(block(ise,nse(ise),mh)%size(jb)*lsize,
     &                       bp%bt(ib)%op(:,lsta),1,
     &                       wk1,1)
                else
!$OMP PARALLEL WORKSHARE
                  wk1=zero
!$OMP END PARALLEL WORKSHARE
                end if

                do ik1=1,nfr
                  ik2=iop(ik1)
                  if(ik2.eq.0) cycle
                  call fermi_sign_op(fsign,b*vop(ik1),iftp,
     &                     nov(1),nov(2),iud(ik1,1),iud(ik1,2),fs)

                  call para_range(1,block(ise,is,mh)%sizex(jb,ik2),
     &                            np_env,myid_env,lsta,lend)

                  ip1=myid_sys+1; ip2=myid_env+1
                  do ix2=1,block(ise,is,mh)%sizex(ib,ik1)
                    ix=block(ise,nse(ise),mh)%stax(ib,ik1)+ix2-1
                    if(ix.lt.idisp(ip1)+1) cycle
                    if(ix.gt.idisp(ip1)+ircnt(ip1)) cycle
!$OMP PARALLEL DO
                    do ix1=lsta,lend
                      wk1(block(ise,nse(ise),mh)%stax(jb,ik2)+ix1-1,ix)
     &               =wk1(block(ise,nse(ise),mh)%stax(jb,ik2)+ix1-1,ix)
     &                 +fs*np(mod(is-1,2)+1)%bp(kb(ik1),ip2)%op(ix1,ix2)
                    enddo
                  enddo
                enddo

                allocate(wk2(block(ise,nse(ise),mh)%size(jb),
     &                       ircnt(myid_sys+1)))

                call mpi_allreduce(wk1,wk2,
     &                block(ise,nse(ise),mh)%size(jb)*ircnt(myid_sys+1),
     &                mpi_kv,mpi_sum,newcomm_env,ierr)

                call gr2d(wk2,block(ise,nse(ise),mh)%size(jb)
     &                    *ircnt(myid_sys+1),bp%bt(ib)%op,
     &                    np_sys,newcomm_sys)

                deallocate(wk1,wk2,ircnt,idisp)
              end if
            end if

          else !NOT FINAL LOOP
            allocate(ircnty(np_env),idispy(np_env))
            call pre_algv2(1,block(ise,is,mh)%size(jb),np_env,
     &                     ircnty,idispy)

            call para_range(1,block(ise,is,mh)%size(ib),
     &                      np_env,myid_env,lsta,lend)

            if(block(ise,is,mh)%ndmx.gt.mts) then
!$OMP PARALLEL DO PRIVATE(ksta,kend)
              do ip=1,np_env
                call para_range(1,block(ise,is,mh)%size(ib),np_env,
     &                          myid_env,ksta,kend)
                allocate(np(mod(is,2)+1)%bp(ib,ip)
     &                   %op(idispy(ip)+1:idispy(ip)+ircnty(ip),
     &                       ksta:kend))
              enddo

              call trabset_op(iop,vop,nov,kb,ise,ib,jb,bp,is,0,one,
     &                        fsign,0)
            else
              do ip=1,np_env
                allocate(np(mod(is,2)+1)%bp(ib,ip)
     &                   %op(idispy(ip)+1:idispy(ip)+ircnty(ip),
     &                       block(ise,is,mh)%size(ib)))
              enddo

              if(is.eq.ns(1)) then
                ip=myid_env+1
!$OMP PARALLEL WORKSHARE
                np(mod(is,2)+1)%bp(ib,ip)%op=zero
!$OMP END PARALLEL WORKSHARE
!$OMP PARALLEL DO PRIVATE(ik2,ix2)
                do ik1=1,nfr
                  ik2=iop(ik1)
                  if(ik2.eq.0) cycle
                  do ix1=max(idispy(ip)+1,
     &                       block(ise,is,mh)%stax(jb,ik2)),
     &                   min(idispy(ip)+ircnty(ip),
     &                       block(ise,is,mh)%stax(jb,ik2)
     &                         +block(ise,is,mh)%sizex(ib,ik1)-1)
                    ix2=ix1-block(ise,is,mh)%stax(jb,ik2)
     &                  +block(ise,is,mh)%stax(ib,ik1)
                    np(mod(is,2)+1)%bp(ib,ip)%op(ix1,ix2)=vop(ik1)
                  enddo
                enddo

                do ip=1,np_env
                  call mpi_bcast(np(mod(is,2)+1)%bp(ib,ip)%op,
     &                 ircnty(ip)*block(ise,is,mh)%size(ib),
     &                 mpi_kv,ip-1,newcomm_env,ierr)
                enddo
              else
!$OMP PARALLEL WORKSHARE
                np(mod(is,2)+1)%bp(ib,myid_env+1)%op=zero
!$OMP END PARALLEL WORKSHARE
                do ik1=1,nfr
                  ik2=iop(ik1)
                  if(ik2.eq.0) cycle
                  call fermi_sign_op(fsign,vop(ik1),iftp,nov(1),nov(2),
     &                               iud(ik1,1),iud(ik1,2),fs)

                  allocate(ircntx(np_env),idispx(np_env))
                  call pre_algv2(1,block(ise,is,mh)%sizex(jb,ik2),
     &                           np_env,ircntx,idispx)

                  call para_range(1,block(ise,is,mh)%sizex(ib,ik1),
     &                            np_sys,myid_sys,lsta,lend)
                  lsize=lend-lsta+1
                  allocate(ircntz(np_sys),idispz(np_sys))
                  call pre_algv(lsize,np_sys,newcomm_sys,ircntz,idispz)

                  ip=myid_env+1
                  allocate(wk1(idispy(ip)+1:idispy(ip)+ircnty(ip),
     &                        lsta:lend))
!$OMP PARALLEL WORKSHARE
                  wk1=zero
!$OMP END PARALLEL WORKSHARE
!$OMP PARALLEL DO PRIVATE(ip2,ix2)
                  do ix=1,np_env*lsize
                    ip2=(ix-1)/lsize+1
                    ix2=mod(ix-1,lsize)+lsta
                    do ix1=max(idispx(ip2)
     &                           +block(ise,is,mh)%stax(jb,ik2),
     &                         idispy(ip)+1),
     &                     min(idispx(ip2)+ircntx(ip2)
     &                          +block(ise,is,mh)%stax(jb,ik2)-1,
     &                         idispy(ip)+ircnty(ip))
                       wk1(ix1,ix2)
     &                    =fs*np(mod(is-1,2)+1)%bp(kb(ik1),ip2)
     &                      %op(ix1-block(ise,is,mh)%stax(jb,ik2)+1,ix2)
                    enddo
                  enddo
                  call gr2d(wk1,ircnty(ip)*lsize,
     &                      np(mod(is,2)+1)%bp(ib,ip)
     &                      %op(:,block(ise,is,mh)%stax(ib,ik1)),
     &                      np_sys,newcomm_sys)

                  deallocate(wk1,ircntx,idispx,ircntz,idispz)
                enddo
                do ip=1,np_env
                  call mpi_bcast(np(mod(is,2)+1)%bp(ib,ip)%op,
     &                 ircnty(ip)*block(ise,is,mh)%size(ib),
     &                 mpi_kv,ip-1,newcomm_env,ierr)
                enddo
              end if
            end if
            deallocate(ircnty,idispy)
          end if
        enddo !END OF LOOP FOR BLOCKS

        if(allocated(np(mod(is-1,2)+1)%bp)) then
          deallocate(np(mod(is-1,2)+1)%bp)
        end if

        if(np_bk.gt.1) then
          do ib=1,block(ise,is,mh)%nbk
            call ck_block(ib,jb,lb,ms,ic,ise,is)
            if(jb.eq.0) cycle

            if(is.eq.nse(ise)) then !CASE OF FINAL LOOP FOR SITES
              if(.not.allocated(bp%bt(ib)%op)) then
                allocate(bp%bt(ib)%op(block(ise,nse(ise),mh)%size(jb),
     &                                block(ise,nse(ise),mh)%size(ib)))
              end if
              call mpi_bcast(bp%bt(ib)%op,
     &                       block(ise,is,mh)%size(jb)
     &                      *block(ise,is,mh)%size(ib),
     &                       mpi_kv,block(ise,is,mh)%kid(ib),
     &                       newcomm_bk,ierr)
            else
              if(.not.allocated(np(mod(is,2)+1)%bp)) then
                allocate(np(mod(is,2)+1)
     &                     %bp(block(ise,is,mh)%nbk,np_env))
              end if

              allocate(ircnty(np_env),idispy(np_env))
              call pre_algv2(1,block(ise,is,mh)%size(jb),np_env,
     &                       ircnty,idispy)
              do ip=1,np_env
                if(block(ise,is,mh)%ndmx.gt.mts) then
                  call para_range(1,block(ise,is,mh)%size(ib),np_env,
     &                            myid_env,ksta,kend)
                else
                  ksta=1
                  kend=block(ise,is,mh)%size(ib)
                end if

                if(.not.allocated(np(mod(is,2)+1)%bp(ib,ip)%op)) then
                  allocate(np(mod(is,2)+1)%bp(ib,ip)
     &                       %op(idispy(ip)+1:idispy(ip)+ircnty(ip),
     &                           ksta:kend))
                end if
                call mpi_bcast(np(mod(is,2)+1)%bp(ib,ip)%op,
     &                         ircnty(ip)*(kend-ksta+1),
     &                         mpi_kv,
     &                         block(ise,is,mh)%kid(ib),
     &                         newcomm_bk,ierr)
              enddo
              deallocate(ircnty,idispy)
            end if
          enddo
        end if
      enddo !END OF LOOP FOR SITES

      if(allocated(np)) deallocate(np)
      if(allocated(nov)) deallocate(nov)
      if(allocated(ie)) deallocate(ie)
      deallocate(ns,ks,ls,lb,ops,iop,vop,kb)

      return
      end
