      subroutine make_tmat(ise,nx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,nx,ib,i,i1,i2,jb,mhc,isec,ista,iend,isize,
     &           jsta,jend,jsize,ista0,iend0,isize0,jsta0,jend0,jsize0,
     &           ksta,kend,ksize,lsta,lend,lsize
#ifdef cmplx_v
      complex(8), 
#else
      real(8),
#endif
     &  allocatable :: tm1(:,:),tm2(:,:),uva(:,:),uv1(:,:)

      isec=mod(ise,2)+1

! --- RESET TRANSFORMATION MATRIX
      if(nx.eq.2.or.iphys.eq.1.or.if_tdmrg.eq.0) then !NEW TIMESTEP OR SINGLE SITE BLOCK
        do ib=1,block(ise,nx,mh)%nbk
          if(allocated(block(ise,nx,1)%b(ib)%tm)) then
            deallocate(block(ise,nx,1)%b(ib)%tm)
          end if

          call para_ranges(1,block(ise,nx,1)%size(ib),np_(ise),
     &                     myid_(ise),ista,iend,isize)
          call para_ranges(1,block(ise,nx,1)%size(ib),np_(isec),
     &                     myid_(isec),jsta,jend,jsize)

          allocate(block(ise,nx,1)%b(ib)%tm(ista:iend,jsta:jend))
!$OMP PARALLEL WORKSHARE
          block(ise,nx,1)%b(ib)%tm=zero
!$OMP END PARALLEL WORKSHARE

!$OMP PARALLEL DO
          do i1=max(ista,jsta),min(iend,jend)
            block(ise,nx,1)%b(ib)%tm(i1,i1)=one
          enddo
        enddo

! --- MAKE TRANSFORMATION MATRIX
      else
        mhc=mod(mh,2)+1
        do ib=1,block(ise,nx,mh)%nbk
          call para_ranges(1,block(ise,nx,mh)%size(ib),
     &                     np_(ise),myid_(ise),ista,iend,isize)
          call para_ranges(1,block(ise,nx,mhc)%size(ib),
     &                     np_(isec),myid_(isec),jsta,jend,jsize)

          if(allocated(block(ise,nx,1)%b(ib)%tm)) then
            deallocate(block(ise,nx,1)%b(ib)%tm)
          end if

          allocate(block(ise,nx,1)%b(ib)%tm(ista:iend,jsta:jend))
!$OMP PARALLEL WORKSHARE
          block(ise,nx,1)%b(ib)%tm=zero
!$OMP END PARALLEL WORKSHARE

          do i=1,nfr
            jb=block(ise,nx,1)%nse(ib,i)
            if(jb.eq.0) cycle

            call para_ranges(1,block(ise,nx,mh)%sizex(ib,i),
     &                       np_(ise),myid_(ise),ista0,iend0,isize0)
            call para_ranges(1,block(ise,nx,mhc)%sizex(ib,i),
     &                       np_(isec),myid_(isec),jsta0,jend0,jsize0)

            call para_ranges(1,block(ise,nx,mh)%sizex(ib,i),
     &                       np_env,myid_env,ksta,kend,ksize)
            call para_ranges(1,block(ise,nx,mh)%size0(ib),
     &                       np_sys,myid_sys,lsta,lend,lsize)

            allocate(uv1(block(ise,nx,mh)%sizex(ib,i),lsta:lend),
     &               uva(block(ise,nx,mh)%sizex(ib,i),
     &                   block(ise,nx,mh)%size0(ib)))

            call gc2d(block(ise,nx,mh)%b(ib)%s(i)%uv,ksize,lsize,
     &                uv1,block(ise,nx,mh)%sizex(ib,i),
     &                np_env,newcomm_env)

            call gr2d(uv1,size(uv1),uva,np_sys,newcomm_sys)

            deallocate(uv1)

            allocate(tm1(block(ise,nx,mh)%size(ib),jsize0))

            if(block(ise,nx,mh)%size(ib).gt.0.and.
     &         isize0.gt.0.and.jsize0.gt.0) then

              call XGEMM(chmm(2),chmm(1),
     &                   block(ise,nx,mh)%size(ib),jsize0,isize0,
     &                   one,
     &                   uva(ista0,1),
     &                   block(ise,nx,mh)%sizex(ib,i),
     &                   block(ise,nx-1,1)%b(jb)%tm,isize0,
     &                   zero,
     &                   tm1,block(ise,nx,mh)%size(ib))

            else
!$OMP PARALLEL WORKSHARE
              tm1=zero
!$OMP END PARALLEL WORKSHARE
            end if

            deallocate(uva)

            call para_ranges(1,block(ise,nx,mhc)%sizex(ib,i),
     &                       np_env,myid_env,ksta,kend,ksize)
            call para_ranges(1,block(ise,nx,mhc)%size0(ib),
     &                       np_sys,myid_sys,lsta,lend,lsize)

            allocate(uv1(block(ise,nx,mhc)%sizex(ib,i),lsta:lend),
     &               uva(block(ise,nx,mhc)%sizex(ib,i),
     &                   block(ise,nx,mhc)%size0(ib)))

            call gc2d(block(ise,nx,mhc)%b(ib)%s(i)%uv,ksize,lsize,
     &                uv1,block(ise,nx,mhc)%sizex(ib,i),
     &                np_env,newcomm_env)

            call gr2d(uv1,size(uv1),uva,np_sys,newcomm_sys)

            deallocate(uv1)

            call para_ranges(1,block(ise,nx,mhc)%size(ib),
     &                       np_(ise),myid_(ise),lsta,lend,lsize)

            allocate(tm2(block(ise,nx,mh)%size(ib),jsize0))

            call mpi_allreduce(tm1,tm2,size(tm1),mpi_kv,mpi_sum,
     &                         newcomm_(ise),ierr)

            deallocate(tm1)

            allocate(tm1(block(ise,nx,mh)%size(ib),lsta:lend))

            if(block(ise,nx,mh)%size(ib).gt.0.and.
     &         lsize.gt.0.and.jsize0.gt.0) then

              call XGEMM(chmm(1),chmm(1),
     &                   block(ise,nx,mh)%size(ib),
     &                   lsize,
     &                   jsize0,
     &                   one,
     &                   tm2,block(ise,nx,mh)%size(ib),
     &                   uva(jsta0,lsta),
     &                   block(ise,nx,mhc)%sizex(ib,i),
     &                   zero,
     &                   tm1,block(ise,nx,mh)%size(ib))

            else
!$OMP PARALLEL WORKSHARE
              tm1=zero
!$OMP END PARALLEL WORKSHARE
            end if

            deallocate(tm2,uva)

            allocate(tm2(block(ise,nx,mh)%size(ib),lsta:lend))

            call mpi_allreduce(tm1,tm2,block(ise,nx,mh)%size(ib)*lsize,
     &                         mpi_kv,mpi_sum,newcomm_(isec),ierr)

            deallocate(tm1)

            allocate(tm1(block(ise,nx,mh)%size(ib),
     &                   block(ise,nx,mhc)%size(ib)))

            call gr2d(tm2,size(tm2),tm1,np_(ise),newcomm_(ise))

!$OMP PARALLEL DO
            do i2=jsta,jend
              do i1=ista,iend
                block(ise,nx,1)%b(ib)%tm(i1,i2)
     &            =block(ise,nx,1)%b(ib)%tm(i1,i2)+tm1(i1,i2)
              enddo
            enddo

            deallocate(tm1,tm2)

          enddo

        enddo
      end if

      return
      end
