      module mod_dmrg_work
      integer(1),allocatable :: i2v(:)
      integer,allocatable :: iex(:,:),
     &                       kd4(:),
     &                       iad(:),
     &                       nv(:,:,:)
      real(8),allocatable :: rphys_tp(:),
     &                       qphys_tp(:),
     &                       time_test(:)
      integer :: icount,
     &           mab2
      integer(8) :: mem_uv,
     &              mem_ts,
     &              mem_op,id_mop,
     &              mem_hm

      type densmat
#ifdef cmplx_v
      complex(8),allocatable ::
#else
      real(8),allocatable :: 
#endif
     &  uv(:,:),
     &  uvf(:,:)
      end type densmat

      type dmrg_data
#ifdef cmplx_v
      complex(8),allocatable ::
#else
      real(8),allocatable ::
#endif
     &  hm(:,:), !block hamiltonian
     &  hmt(:,:,:), !hopping term (for pump etc.)
     &  tm(:,:)  !translation matrix between 2 spaces
      type(densmat),allocatable :: s(:)
      end type dmrg_data

      type blocks
      integer :: nbk,ndmx,
     &           isbk,iebk,
     &           isbk1,iebk1,
     &           isbk2,iebk2,
     &           isbk3,iebk3,
     &           isbk4,iebk4
      integer,allocatable :: nud(:,:),   !number of up- and down-spin
     &                       size(:),    !trancated dimension
     &                       size0(:),   !original dimension
     &                       sizex(:,:), !dimension by state of added site
     &                       stax(:,:),  !initial number of state of added site in 'size'
     &                       b2b(:,:,:),
     &                       nse(:,:),
     &                       kid(:),
     &                       ista0(:,:),
     &                       iend0(:,:),
     &                       isize0(:,:),
     &                       ista(:,:),
     &                       iend(:,:),
     &                       isize(:,:),
     &                       chbk(:),
     &                       ichbk(:)
      type(dmrg_data),allocatable :: b(:)
      end type blocks
      type(blocks),allocatable :: block(:,:,:)  !kind of system- or environment-block

      type add
      integer,allocatable :: nse(:)
      end type add

      type bkdiago
      integer :: size,
     &           sta,
     &           end,
     &           up,
     &           dw
      integer,allocatable :: ibs(:,:),
     &                       sizex(:),
     &                       stax(:),
     &                       endx(:),
     &                       ivs(:),
     &                       ive(:),
     &                       isz(:),
     &                       ircntv(:,:),
     &                       idispv(:,:)
      type(add),allocatable :: ap(:)
      end type bkdiago
      type(bkdiago),allocatable :: bk(:,:,:)

      type operators
#ifdef cmplx_v
      complex(8),allocatable :: 
#else
      real(8),allocatable :: 
#endif
     &  op(:,:)
      end type operators

      type sngl_op
#ifdef cmplx_v
      complex(8),allocatable :: 
#else
      real(8),allocatable :: 
#endif
     &  fs(:),
     &  vo(:)
      integer,allocatable :: jbk(:),
     &                       io(:)
      type(operators),allocatable :: bt(:)
      end type sngl_op

      type bop
      type(operators),allocatable :: bt(:)
      type(sngl_op),allocatable :: st(:)
#ifdef cmplx_v
      complex(8),allocatable :: 
#else
      real(8),allocatable :: 
#endif
     &  fs(:),
     &  vo(:)
      integer,allocatable :: jbk(:),
     &                       io(:),
     &                       ns(:,:,:)
      end type bop
      type(bop),allocatable :: kop(:,:),pop(:,:)

      type temp_array
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: uv(:,:),
     &                 ht(:,:),
     &                 op(:,:)
      end type temp_array
      type(temp_array),allocatable :: mpix(:),ast(:,:)

      type bvec
#ifdef cmplx_v
      complex(8),allocatable :: 
#else
      real(8),allocatable :: 
#endif
     &  b(:,:)
      end type bvec

      type avec
      type(bvec),allocatable :: ap(:)
      integer,allocatable :: jlb(:)
      end type avec
      type(avec),allocatable :: v(:,:),
     &                          v2(:,:),
     &                          vm(:,:),
     &                          vx(:),
     &                          vy(:),
     &                          vk(:,:)

      type top
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: op(:,:)
      end type top
      type tbk
      type(top),allocatable :: b(:),bp(:,:)
      end type tbk
      type(tbk),allocatable :: np(:)

      type hm
      integer :: nh
      integer,allocatable :: kh(:),ic(:),np(:,:),fst(:)
      end type hm
      type(hm),allocatable :: th(:)

      type ck_h
      integer,allocatable :: num(:),ist(:,:)
      end type ck_h
      type(ck_h),allocatable :: ck2(:,:),ckc(:,:)

      type ck_h4
      integer,allocatable :: num(:),ist(:,:)
      integer :: ityp,ntyp
      end type ck_h4
      type(ck_h4),allocatable :: ck4(:,:)

      type inop
      integer :: mi,fi
      integer,allocatable :: ni(:),ki(:)
      end type inop

      end module mod_dmrg_work
