      subroutine op_dm(id,msx,ise,ib,i1,jb,i2,nb,mb,opx,jsize,tb)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,ib,jb,i2,i1,ise,ix1,ix2,msx(4),jsize,
     &           ista,iend,isize,lsta,lend,lsize,ix1_min,ix1_max,
     &           ix2_min,ix2_max
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  opx(jsize,*),ax
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: uv0(:,:),uv1(:,:),opy(:,:)
      type(temp_array) :: nb(nbk),mb(nbk)
      type(blocks) :: tb

      ax=one!*min(pvw,1.d-5)  !weight of matrix element

      if((msx(1).ne.0.and.ise.eq.1).or.
     &   (msx(4).ne.0.and.ise.eq.2)) then   !BLOCK
        if(id.eq.1) then
          call para_ranges(1,tb%sizex(jb,i1),np_(2),myid_(2),ista,iend,
     &                     isize)

          call para_ranges(1,tb%sizex(ib,i2),np_(1),myid_(1),lsta,lend,
     &                     lsize)

          allocate(uv1(ircnt2(myid_(2)+1,ib),tb%size0(ib)))

          call gr2d(mb(ib)%uv,
     &              ircnt1(myid_(1)+1,ib)*ircnt2(myid_(2)+1,ib),
     &              uv1,np_(1),newcomm_(1))

          allocate(uv0(ircnt2(myid_(2)+1,ib),lsta:lend))

          if(lsize.gt.0) then
            call XCOPY(ircnt2(myid_(2)+1,ib)*lsize,
     &                 uv1(:,tb%stax(ib,i2)+lsta-1),1,uv0,1)
          end if

          deallocate(uv1)

          allocate(uv1(tb%size0(ib),lsta:lend))

          call gc2d(uv0,ircnt2(myid_(2)+1,ib),lend-lsta+1,
     &              uv1,tb%size0(ib),np_(2),newcomm_(2))

          deallocate(uv0)

          allocate(uv0(tb%sizex(ib,i2),lsta:lend))

          call copy_2d(uv0,1,tb%sizex(ib,i2),lsta,lend,
     &                 uv1,tb%size0(ib),tb%stax(ib,i2)-1)

          deallocate(uv1)

          allocate(opy(ista:iend,tb%sizex(ib,i2)))

          call copy_2d(opy,ista,iend,1,tb%sizex(ib,i2),
     &                 opx,jsize,0)

          allocate(uv1(ista:iend,lsta:lend))
#ifdef tp_safe
!$OMP PARALLEL WORKSHARE
          uv1=zero
!$OMP END PARALLEL WORKSHARE
#endif
          if(lsize.gt.0.and.isize.gt.0) then
            call XGEMM(chmm(1),chmm(1),
     &           isize,
     &           lsize,
     &           tb%sizex(ib,i2),
     &           one,
     &           opy,
     &           isize,
     &           uv0,
     &           tb%sizex(ib,i2),
     &           zero,
     &           uv1,
     &           isize)
#ifndef tp_safe
          else
!$OMP PARALLEL WORKSHARE
            uv1=zero
!$OMP END PARALLEL WORKSHARE
#endif
          end if

          deallocate(uv0)
          allocate(uv0(ista:iend,tb%sizex(jb,i1)))
#ifdef tp_safe
!$OMP PARALLEL WORKSHARE
          uv0=zero
!$OMP END PARALLEL WORKSHARE
#endif
          if(lsize.gt.0.and.isize.gt.0) then
            call XGEMM(chmm(1),chmm(2),
     &           isize,
     &           tb%sizex(jb,i1),
     &           lsize,
     &           ax,
     &           uv1,
     &           isize,
     &           opx(:,lsta:lend),
     &           jsize,
     &           zero,
     &           uv0,
     &           isize)
#ifndef tp_save
          else
!$OMP PARALLEL WORKSHARE
            uv0=zero
!$OMP END PARALLEL WORKSHARE
#endif
          end if

          deallocate(opy,uv1)

          allocate(uv1(ista:iend,tb%sizex(jb,i1)))

          call mpi_allreduce(uv0,uv1,isize*tb%sizex(jb,i1),
     &                       mpi_kv,mpi_sum,newcomm_(1),ierr)

          deallocate(uv0)

          allocate(uv0(tb%sizex(jb,i1),tb%sizex(jb,i1)))

          call gc2d(uv1,isize,tb%sizex(jb,i1),
     &              uv0,tb%sizex(jb,i1),np_(2),newcomm_(2))

          deallocate(uv1)

        elseif(id.eq.2) then
          call para_ranges(1,tb%sizex(ib,i2),np_sys,myid_sys,ista,iend,
     &                     isize)

          call para_ranges(1,tb%sizex(jb,i1),np_env,myid_env,lsta,lend,
     &                     lsize)

          allocate(uv0(tb%size0(ib),ircnt1(myid_(1)+1,ib)))

          call gc2d(mb(ib)%uv,ircnt2(myid_(2)+1,ib),
     &              ircnt1(myid_(1)+1,ib),uv0,tb%size0(ib),np_(2),
     &              newcomm_(2))

          allocate(uv1(tb%size0(ib),tb%size0(ib)))

          call gr2d(uv0,tb%size0(ib)*ircnt1(myid_(1)+1,ib),
     &              uv1,np_(1),newcomm_(1))

          deallocate(uv0)

          allocate(uv0(tb%sizex(ib,i2),ista:iend))

          if(isize.gt.0) then
            call copy_2d(uv0,1,tb%sizex(ib,i2),ista,iend,
     &                   uv1(:,tb%stax(ib,i2)+ista-1),tb%size0(ib),
     &                   tb%stax(ib,i2)-1)
          end if

          deallocate(uv1)

          allocate(opy(ista:iend,tb%sizex(jb,i1)))

          call copy_2d(opy,ista,iend,1,tb%sizex(jb,i1),
     &                 opx,jsize,0)

          allocate(uv1(lsta:lend,ista:iend))
#ifdef tp_safe
!$OMP PARALLEL WORKSHARE
          uv1=zero
!$OMP END PARALLEL WORKSHARE
#endif
          if(isize.gt.0.and.lsize.gt.0) then
            call XGEMM(chmm(2),chmm(1),
     &           lsize,
     &           isize,
     &           tb%sizex(ib,i2),
     &           one,
     &           opx(:,lsta:lend),
     &           jsize,
     &           uv0,
     &           tb%sizex(ib,i2),
     &           zero,
     &           uv1,
     &           lsize)
#ifndef tp_safe
          else
!$OMP PARALLEL WORKSHARE
            uv1=zero
!$OMP END PARALLEL WORKSHARE
#endif
          end if

          deallocate(uv0)
          allocate(uv0(lsta:lend,tb%sizex(jb,i1)))
#ifdef tp_safe
!$OMP PARALLEL WORKSHARE
          uv0=zero
!$OMP END PARALLEL WORKSHARE
#endif
          if(isize.gt.0.and.lsize.gt.0) then
            call XGEMM(chmm(1),chmm(1),
     &           lsize,
     &           tb%sizex(jb,i1),
     &           isize,
     &           ax,
     &           uv1,
     &           lsize,
     &           opy,
     &           isize,
     &           zero,
     &           uv0,
     &           lsize)
#ifndef tp_safe
          else
!$OMP PARALLEL WORKSHARE
            uv0=zero
!$OMP END PARALLEL WORKSHARE
#endif
          end if

          deallocate(opy,uv1)

          allocate(uv1(lsta:lend,tb%sizex(jb,i1)))

          call mpi_allreduce(uv0,uv1,lsize*tb%sizex(jb,i1),
     &                       mpi_kv,mpi_sum,newcomm_(1),ierr)

          deallocate(uv0)

          allocate(uv0(tb%sizex(jb,i1),tb%sizex(jb,i1)))

          call gc2d(uv1,lsize,tb%sizex(jb,i1),
     &              uv0,tb%sizex(jb,i1),np_(2),newcomm_(2))

          deallocate(uv1)
        end if

        call mpi_ixbd(tb,jb,i1,i1,ix1_min,ix1_max,ix2_min,ix2_max)
!$OMP PARALLEL DO
         do ix2=ix2_min,ix2_max
           do ix1=ix1_min,ix1_max
            nb(jb)%uv(ix1,ix2)=nb(jb)%uv(ix1,ix2)
     &                         +uv0(ix1-tb%stax(jb,i1)+1,
     &                              ix2-tb%stax(jb,i1)+1)
          enddo
        enddo
        deallocate(uv0)
      else   !ADDED SITE
        allocate(uv0(tb%size0(ib),ircnt1(myid_(1)+1,ib)))

        call gc2d(mb(ib)%uv,ircnt2(myid_(2)+1,ib),
     &            ircnt1(myid_(1)+1,ib),uv0,tb%size0(ib),np_(2),
     &            newcomm_(2))

        allocate(uv1(tb%size0(ib),tb%size0(ib)))

        call gr2d(uv0,tb%size0(ib)*ircnt1(myid_(1)+1,ib),
     &            uv1,np_(1),newcomm_(1))

        deallocate(uv0)

        call mpi_ixbd(tb,jb,i1,i1,ix1_min,ix1_max,ix2_min,ix2_max)
!$OMP PARALLEL DO
        do ix2=ix2_min,ix2_max
          do ix1=ix1_min,ix1_max
            nb(jb)%uv(ix1,ix2)=nb(jb)%uv(ix1,ix2)
     &         +ax*uv1(ix1-tb%stax(jb,i1)+tb%stax(ib,i2),
     &                 ix2-tb%stax(jb,i1)+tb%stax(ib,i2))
          enddo
        enddo

        deallocate(uv1)
      end if

      return
      end
