      subroutine op_wf(iv1,iv2,iv3)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv1,iv2,iv3,iv,ib,ix,ivx(2)
      integer(8) :: imem
      real(8) :: ft
      integer,allocatable :: ns(:),isp(:)
      real(8),allocatable :: rx(:),ry(:)
      type(avec),allocatable :: v0(:),va(:,:)

! --- INITIALIZE VECTORS
      ivx=(/iv2,iv3/)
      allocate(va(isbk0:iebk0,3))
      call init_vtmp(v(isbk1:iebk1,iv1),va(isbk0:iebk0,1))
      do iv=2,3
        call lz_acv(va(isbk0:iebk0,iv),isbk0,iebk0,1,imem)
      enddo

! --- OPERATION FOURIER-TRANSFORMED OPERATOR
      allocate(rx(nsite),ry(nsite),isp(nsite))
      if(myid_dmrg.eq.key_rank) then
        open(10,file=file_posit,status='old')
        do ix=1,nsite
          read(10,*) isp(ix),rx(ix),ry(ix)
        enddo
        close(10)
      end if
      call mpi_bcast(isp,nsite,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(rx,nsite,MPI_REAL8,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(ry,nsite,MPI_REAL8,key_rank,newcomm_dmrg,ierr)

      allocate(ns(ddmrg(1)%nop))

      do ix=myid_int+1,nsite,np_int
        if(isp(ix).eq.0) cycle

        allocate(v0(nbk))
        do ib=1,nbk; allocate(v0(ib)%ap(ad(nfrx(1),nfrx(2)))); enddo
        call vclr(v0(isbk0:iebk0),isbk0,iebk0,zero)

        ns(1:ddmrg(1)%nop)=ix
        call phys_v(va(:,1),ddmrg(1)%nop,ns,ddmrg(1)%iop,v0)

        call ft_coeff('cos_'//boundary,rx(ix),ry(ix),
     &                ddmrg(1)%qx,ddmrg(1)%qy,ft)
        if(abs(ft).gt.1.d-16)
     &    call adv(ft,v0(isbk0:iebk0),va(:,2),isbk0,iebk0)

        call ft_coeff('sin_'//boundary,rx(ix),ry(ix),
     &                ddmrg(1)%qx,ddmrg(1)%qy,ft)
        if(abs(ft).gt.1.d-16)
     &    call adv(ft,v0(isbk0:iebk0),va(:,3),isbk0,iebk0)

        deallocate(v0)
      enddo

! --- SET OPERATED VECTORS
      do iv=1,2
        call set_vec(va(isbk0:iebk0,iv+1),v(isbk1:iebk1,ivx(iv)))
      enddo

      deallocate(ns,isp,rx,ry,va)

      return
      end
