      subroutine phys_v(va,ms,ns,ks,v0)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ms,ns(ms),ks(ms),ib,ix1,ix2,jb,ih
      integer,allocatable :: msx(:),nsx(:,:),ksx(:,:),nx(:)
      real(8) :: bf
      type(avec) :: va(isbk0:iebk0),v0(nbk)
      type(bop),allocatable :: bp(:),pp(:)
      type(avec),allocatable :: vin(:)
      type(mpi_block),allocatable :: pmpi(:)

      ih=1
! --- INITIALIZE
      id_mop=0   !0:NOT CHECKING MEMORY USEGE
      allocate(msx(4),nsx(ms,4),ksx(ms,4),nx(nop),bp(2),pp(4))

! --- OPERATORS
      allocate(bp(1)%jbk(nbk),
     &         bp(1)%io(nfrx(1)),bp(1)%vo(nfrx(1)),
     &         bp(2)%io(nfrx(2)),bp(2)%vo(nfrx(2)),
     &         bp(1)%fs(nfrx(1)),bp(2)%fs(nfrx(2)))
!$OMP PARALLEL WORKSHARE
      bp(1)%io(1:nfrx(1))=0
      bp(2)%io(1:nfrx(2))=0
      bp(1)%vo(1:nfrx(1))=zero
      bp(2)%vo(1:nfrx(2))=zero
!$OMP END PARALLEL WORKSHARE

      call check_op(ms,ns,ks,msx,nsx,ksx,bf)
      if(msx(1).ne.0) then !j
        call make_operators(msx(1),nsx(:,1),ksx(:,1),bp(1),one,fsi(0))
      end if
      if(nas.eq.0) then
        bp(1)%io(1)=1
        bp(1)%vo(1)=one
      else
        call single_opx(msx(2),ksx(:,2),bp(1)%io,bp(1)%vo,one) !i
      end if
      if(nae.eq.0) then
        bp(2)%io(1)=1
        bp(2)%vo(1)=one
      else
        call single_opx(msx(3),ksx(:,3),bp(2)%io,bp(2)%vo,one) !k
      end if
      if(msx(4).ne.0) then !l
        call make_operators(msx(4),nsx(:,4),ksx(:,4),bp(2),one,fsi(0))
      end if

! --- BLOCKS
      nx=0
      do ix1=1,msx(1)
        nx(abs(ksx(ix1,1)))=nx(abs(ksx(ix1,1)))+sign(1,ksx(ix1,1))
      enddo
      do ix1=1,msx(2)
        nx(abs(ksx(ix1,2)))=nx(abs(ksx(ix1,2)))+sign(1,ksx(ix1,2))
      enddo

      do ib=1,nbk
        bp(1)%jbk(ib)=ib
        do ix1=1,nop
          do ix2=1,abs(nx(ix1))
            if(bp(1)%jbk(ib).eq.0) exit
            bp(1)%jbk(ib)
     &        =bk(bp(1)%jbk(ib),1,ih)%ibs(-sign(1,nx(ix1)),ix1)
          enddo
        enddo
      enddo
      deallocate(nx)

! --- FERMION SIGN
      allocate(nx(2))
      do ix1=1,2
        nx=0
        if(ix1.eq.1) then
          do ix2=1,ms
            if(ns(ix2).lt.iad(ix1)) then
              nx(1)=nx(1)+nch(1,abs(ks(ix2)))*sign(1,ks(ix2))
              nx(2)=nx(2)+nch(2,abs(ks(ix2)))*sign(1,ks(ix2))
            end if
          enddo
          do ix2=1,ms
            if(ns(ix2).eq.iad(ix1)) then
              if(abs(nx(1)+nch(1,abs(ks(ix2)))*sign(1,ks(ix2)))
     &             .lt.abs(nx(1)).or.
     &           abs(nx(2)+nch(2,abs(ks(ix2)))*sign(1,ks(ix2)))
     &             .lt.abs(nx(2))) then
                nx(1)=nx(1)+nch(1,abs(ks(ix2)))*sign(1,ks(ix2))
                nx(2)=nx(2)+nch(2,abs(ks(ix2)))*sign(1,ks(ix2))
              end if
            end if
          enddo
        elseif(ix1.eq.2) then
          do ix2=1,ms
            if(ns(ix2).gt.iad(ix1)) then
              nx(1)=nx(1)+nch(1,abs(ks(ix2)))*sign(1,ks(ix2))
              nx(2)=nx(2)+nch(2,abs(ks(ix2)))*sign(1,ks(ix2))
            end if
          enddo
          do ix2=1,ms
            if(ns(ix2).eq.iad(ix1)) then
              if(abs(nx(1)+nch(1,abs(ks(ix2)))*sign(1,ks(ix2)))
     &              .lt.abs(nx(1)).or.
     &           abs(nx(2)+nch(2,abs(ks(ix2)))*sign(1,ks(ix2)))
     &              .lt.abs(nx(2))) then
                nx(1)=nx(1)+nch(1,abs(ks(ix2)))*sign(1,ks(ix2))
                nx(2)=nx(2)+nch(2,abs(ks(ix2)))*sign(1,ks(ix2))
              end if
            end if
          enddo
        end if

        if(iftp.eq.1) then
!$OMP PARALLEL DO
          do ix2=1,nfrx(ix1)
            bp(ix1)%fs(ix2)=(fsi(0)**(nx(1)*iud(ix2,1)))
     &                     *(fsi(0)**(nx(2)*iud(ix2,2)))
          enddo
        elseif(iftp.eq.2) then
!$OMP PARALLEL DO
          do ix2=1,nfrx(ix1)
            bp(ix1)%fs(ix2)
     &        =fsi(0)**((nx(1)+nx(2))*(iud(ix2,1)+iud(ix2,2)))
          enddo
        else
!$OMP PARALLEL DO
          do ix2=1,nfrx(ix1)
            bp(ix1)%fs(ix2)=1.d0
          enddo
        end if
      enddo

! ---
      if(msx(1).ne.0.and.msx(4).ne.0) then
        call para_op(5,0,bp,pp)
      elseif(msx(1).ne.0.and.msx(4).eq.0) then
        call para_op(3,0,bp,pp)
      elseif(msx(1).eq.0.and.msx(4).ne.0) then
        call para_op(4,0,bp,pp)
      end if

! --- OPERATIONS
      allocate(nv(nfr,nfr,nbk))
!$OMP PARALLEL WORKSHARE
      nv=0
!$OMP END PARALLEL WORKSHARE

      allocate(vin(isbk0:iebk0))
      call mpi_vec(va,vin)
      if(msx(1).ne.0.and.msx(4).ne.0) then
        call mv_4(0,vin,v0,bp,pp,one)
      elseif(msx(1).ne.0.and.msx(4).eq.0) then
        call mv_sint(0,vin,v0,bp,pp,one)
      elseif(msx(1).eq.0.and.msx(4).ne.0) then
        call mv_eint(0,va,v0,bp,pp,one)
      else
        call mv_aint(0,vin,v0,bp,one)
      end if
      deallocate(vin)

      if(np_bk.gt.1) then
        allocate(pmpi(nbk))
        do ib=1,nbk
          pmpi(ib)%ic=0
          if(.not.allocated(pmpi(ib)%id)) then
            allocate(pmpi(ib)%id(1))
          end if
          pmpi(ib)%id(1)=-1
          jb=bp(1)%jbk(ib)
          if(jb.eq.0) cycle
          if(kid0(jb).eq.myid_bk) then
            pmpi(jb)%ic=1
            if(.not.allocated(pmpi(jb)%id)) then
              allocate(pmpi(jb)%id(1))
            end if
            pmpi(jb)%id(1)=kid0(ib)
          elseif(kid0(ib).eq.myid_bk) then
            pmpi(jb)%ic=1
          end if
        enddo

        call mpi_bk(v0,pmpi)
        deallocate(pmpi)
      end if

!!!      call mpi_add(v0)
      call mpi_mx(v0)

      deallocate(nv)

! --- FINALIZE
      deallocate(msx,nsx,ksx,nx,bp,pp)

      return
      end
