      subroutine read_scenario()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ios,i0,i1
      real(8) :: tlength
      character(64) para

! --- COUNT NUMBER OF EVENTS
      if(myid_dmrg.eq.key_rank) then
        open(11,file=file_scenario,status='old',err=990)
        id_tdmrg=1
        ios=0
        do while(ios.ge.0)
          read(11,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          if(index(para,'#').ne.0) cycle
          if(index(para,'P').ne.0) then !lazer
            num_ev=num_ev+1
          elseif(index(para,'X').ne.0) then !relaxation
            num_ev=num_ev+1
          end if
        enddo
  990   close(11)
      end if

! --- BROAD CAST PARAMETERS
      call mpi_bcast(id_tdmrg,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      if(id_tdmrg.eq.0) return
      if(id_multi.eq.0) ns_ech=1
      call mpi_bcast(num_ev,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      allocate(tdmrg(num_ev))

! --- READ EACH EVENT FROM INPUT FILE
      if(myid_dmrg.eq.key_rank) then
        num_ev=0

        open(11,file=file_scenario,status='old')
        ios=0

        do while(ios.ge.0)
          read(11,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          write(iso,'(a)') para

          if(index(para,'#').ne.0) cycle
          if(index(para,'c').ne.0) cycle

          num_ev=num_ev+1

! ----- PARAMETERS OF EVENTS
! ----- LASER
          if(index(para,'P').ne.0) then
            id_hop=1
            tdmrg(num_ev)%ks=1
            tdmrg(num_ev)%is=1
            i0=index(para,':')
            if(i0.ne.0) then
              call read_time_tDMRG(para,i0,i1,tlength,tdmrg(num_ev)%ts)

              allocate(tdmrg(num_ev)%pt(4)) !pt(1):A_0,pt(2):t_0,pt(3):w_p,pt(4):sigma_p

              call trace_char_d(para,'A_0',tdmrg(num_ev)%pt(1))
              call trace_char_d(para,'t_0',tdmrg(num_ev)%pt(2))
              call trace_char_d(para,'w_p',tdmrg(num_ev)%pt(3))
              call trace_char_d(para,'t_d',tdmrg(num_ev)%pt(4))
            end if

! ----- RELAXATION
          elseif(index(para,'X').ne.0) then
            tdmrg(num_ev)%ks=0
            tdmrg(num_ev)%is=1
            i0=index(para,':')
            call read_time_tDMRG(para,i0,i1,tlength,tdmrg(num_ev)%ts)
            call trace_char_i(para,'ns',tdmrg(num_ev)%is)
          end if

! ----- NUMBER OF SWEEPS IN EACH EVENT
          tdmrg(num_ev)%ns=int(((tlength+1.d-306)/tdmrg(num_ev)%ts))
     &                     *ns_ech
        enddo
        close(11)
      end if

! ----- BROAD CAST PARAMETERS OF EACH EVENT
      do i0=1,num_ev
        call mpi_bcast(tdmrg(i0)%is,1,mpi_integer,key_rank,newcomm_dmrg,
     &                 ierr)
        call mpi_bcast(tdmrg(i0)%ks,1,mpi_integer,key_rank,newcomm_dmrg,
     &                 ierr)
        call mpi_bcast(tdmrg(i0)%ns,1,mpi_integer,key_rank,newcomm_dmrg,
     &                 ierr)
        call mpi_bcast(tdmrg(i0)%ts,1,MPI_REAL8,key_rank,newcomm_dmrg,
     &                 ierr)
        if(tdmrg(i0)%ks.eq.1) then !laser
          if(.not.allocated(tdmrg(i0)%pt)) allocate(tdmrg(i0)%pt(4))
          call mpi_bcast(tdmrg(i0)%pt,4,MPI_REAL8,key_rank,newcomm_dmrg,
     &                   ierr)
        end if
      enddo
      call mpi_bcast(id_hop,1,mpi_integer,key_rank,newcomm_dmrg,ierr)

      nsweep_t=sum(tdmrg(1:num_ev)%ns)

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine read_time_tDMRG(para,i0,i1,tlength,tstep)
      implicit none
      include 'mpif.h'
      integer :: i0,i1
      real(8) :: tlength,tstep
      character(64) para

      i1=i0+index(para(i0+1:),':')
      read(para(i0+1:i1-1),*) tlength
      i0=i1
      i1=i0+index(para(i0+1:),':')
      read(para(i0+1:i1-1),*) tstep

      return
      end
