      subroutine split_comm_bm()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iclr,ikey,isp(2)

! --- SETTING MPI PARALLELIZATION
! ----- BLOCK V.S. MATRIX & VECTOR
      if(index(pal%block,'A').ne.0.or.
     &   index(pal%block,'a').ne.0) then
        iclr=0
        ikey=myid_bm
      elseif(index(pal%block,'N').ne.0.or.
     &       index(pal%block,'n').ne.0) then
        iclr=myid_bm !np_bk=1
        ikey=0
      elseif(index(pal%block,'D').ne.0.or.
     &       index(pal%block,'d').ne.0) then
        iclr=myid_bm/pal%n_block
        ikey=mod(myid_bm,pal%n_block)
      elseif(index(pal%block,'S').ne.0.or.
     &       index(pal%block,'s').ne.0) then
        call fact2(np_bm,isp)
        iclr=myid_bm/minval(isp)
        ikey=mod(myid_bm,minval(isp))
      else
        call fact2(np_bm,isp)
        iclr=myid_bm/maxval(isp)
        ikey=mod(myid_bm,maxval(isp))
      end if

      call mpi_comm_split(newcomm_bm,iclr,ikey,newcomm_bk,ierr)
      call mpi_comm_rank(newcomm_bk,myid_bk,ierr)
      call mpi_comm_size(newcomm_bk,np_bk,ierr)
      call mpi_comm_split(newcomm_bm,ikey,iclr,newcomm_mx,ierr)
      call mpi_comm_rank(newcomm_mx,myid_mx,ierr)
      call mpi_comm_size(newcomm_mx,np_mx,ierr)

      call mpi_bcast(np_bk,1,mpi_integer,0,newcomm_mx,ierr)
      call mpi_bcast(myid_bk,1,mpi_integer,0,newcomm_mx,ierr)

! ----- VECTOR V.S. MATRIX
      if(index(pal%vector,'A').ne.0.or.
     &   index(pal%vector,'a').ne.0) then
        iclr=0
        ikey=myid_mx
      elseif(index(pal%vector,'N').ne.0.or.
     &       index(pal%vector,'n').ne.0) then
        iclr=myid_mx
        ikey=0
      elseif(index(pal%vector,'D').ne.0.or.
     &       index(pal%vector,'d').ne.0) then
        iclr=myid_mx/pal%n_vector
        ikey=mod(myid_mx,pal%n_vector)
      elseif(index(pal%vector,'S').ne.0.or.
     &       index(pal%vector,'s').ne.0) then
        call fact2(np_mx,isp)
        iclr=myid_mx/minval(isp)
        ikey=mod(myid_mx,minval(isp))
      else
        call fact2(np_mx,isp)
        iclr=myid_mx/maxval(isp)
        ikey=mod(myid_mx,maxval(isp))
      end if

      call mpi_comm_split(newcomm_mx,iclr,ikey,newcomm_vec,ierr)
      call mpi_comm_rank(newcomm_vec,myid_vec,ierr)
      call mpi_comm_size(newcomm_vec,np_vec,ierr)
      call mpi_comm_split(newcomm_mx,ikey,iclr,newcomm_se,ierr)
      call mpi_comm_rank(newcomm_se,myid_se,ierr)
      call mpi_comm_size(newcomm_se,np_se,ierr)

! ----- SYSTEM V.S. ENVIRONMENT
      if(index(pal%matrix_env,'A').ne.0.or.
     &   index(pal%matrix_env,'a').ne.0) then
        call split_comm(newcomm_se,myid_se,np_se,1,
     &                  newcomm_env,myid_env,np_env,
     &                  newcomm_sys,myid_sys,np_sys)
      elseif(index(pal%matrix_env,'N').ne.0.or.
     &       index(pal%matrix_env,'n').ne.0) then
        call split_comm(newcomm_se,myid_se,np_se,np_se,
     &                  newcomm_env,myid_env,np_env,
     &                  newcomm_sys,myid_sys,np_sys)
      elseif(index(pal%matrix_env,'D').ne.0.or.
     &       index(pal%matrix_env,'d').ne.0) then
        call split_comm(newcomm_se,myid_se,np_se,
     &                  np_se/pal%n_matrix_env,
     &                  newcomm_env,myid_env,np_env,
     &                  newcomm_sys,myid_sys,np_sys)
      elseif(index(pal%matrix_env,'S').ne.0.or.
     &       index(pal%matrix_env,'s').ne.0) then
        call fact2(np_se,isp)
        call split_comm(newcomm_se,myid_se,np_se,maxval(isp),
     &                  newcomm_env,myid_env,np_env,
     &                  newcomm_sys,myid_sys,np_sys)
      else
        call fact2(np_se,isp)
        call split_comm(newcomm_se,myid_se,np_se,minval(isp),
     &                  newcomm_env,myid_env,np_env,
     &                  newcomm_sys,myid_sys,np_sys)
      end if

      newcomm_(1)=newcomm_sys
      myid_(1)=myid_sys
      np_(1)=np_sys
      newcomm_(2)=newcomm_env
      myid_(2)=myid_env
      np_(2)=np_env

! ----- ENVIRONMENT & VECTOR V.S. SYSTEM
      call split_comm(newcomm_mx,myid_mx,np_mx,np_sys,
     &                newcomm_ev,myid_ev,np_ev,
     &                newcomm_sys,myid_sys,np_sys)

      allocate(np_ma(np_bk))
      if(myid_mx.eq.0) then
        call mpi_allgather(np_mx,1,mpi_integer,np_ma,1,mpi_integer,
     &                     newcomm_bk,ierr)
      end if
      call mpi_bcast(np_ma,np_bk,mpi_integer,0,newcomm_mx,ierr)

!      if(myid.eq.key_rank) then
!        write(6,*) myid,np_ma
!      end if
!      call mpi_finalize(ierr); stop

      return
      end
