      subroutine tdmrg_target()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv,ix
      integer(8) :: imem
      real(8),allocatable :: ene_time(:)
      type(avec),allocatable :: v0(:)

      if(myid_dmrg.eq.key_rank) then
        write(iso,'(1x,a)') '# tDMRG calculation'
        write(iso,'(1x,a)') '# Kernel polynomial method'
      end if

      if(ich_time.eq.1) then !CHECK MAX. AND MIN. EIGEN VALUE
        allocate(v0(isbk1:iebk1))
        call lz_acv(v0,isbk1,iebk1,0,imem)
        call vcopy(v(isbk1:iebk1,1),v0)
        call lanczos(v0,1,mab2)
        deallocate(v0)
      end if

      call rpm_parameters() !RPM PARAMETERS

      if(id_mapping.eq.1) then
        call tdep_rpm(v(:,2),v(:,2)) !TIME-DEPENDING STATE
      else 
        call tdep_rpm(v(:,1),v(:,1+id_multi)) !TIME-DEPENDING STATE
      end if

      allocate(ene_time(tdmrg(itdmrg)%is))
      do ix=1+id_multi,ntargd
        call energy(v(:,ix),ene_time(ix-id_multi))
      enddo
      ene_t=ene_time(tdmrg(itdmrg)%is)

      if(myid_dmrg.eq.key_rank) then
        write(iso,'(5x,a,5x,a)') '<  time  >','< energy >'
        do ix=1+id_multi,ntargd
          write(iso,'(2x,f12.5,2x,f14.7)')
     &      ptime+(tdmrg(itdmrg)%ts/tdmrg(itdmrg)%is)*(ix-id_multi),
     &      ene_time(ix-id_multi)
        enddo
      end if

      if(iphys.eq.1) then !PHYSICAL QUANTITES AND UPDATE
        if(myid_dmrg.eq.key_rank) then
          write(iso,'(1x,a)') '# physical quantities'
        end if

        ix=1+id_multi

        do iv=ix,ntargd
          if(myid_dmrg.eq.key_rank) then
            write(iso,*)
            write(iso,'(1x,a,2x,f12.7)') '# (time): ',
     &        ptime+(tdmrg(itdmrg)%ts/tdmrg(itdmrg)%is)*(iv-id_multi)
          end if

          if(id_spin.eq.0) then !ELECTRON MODEL
            if(id_current.eq.1) call current_1D(iv)
            if(id_doublon.eq.1) call doublon(iv)
          elseif(id_spin.ge.1) then !SPIN MODEL
          end if

          call phys_main(iv)
        enddo

        ptime=ptime+tdmrg(itdmrg)%ts
        phys(2)%dsw(icphys)=ene_time(tdmrg(itdmrg)%is)

        if(id_multi.eq.1.and.id_mapping.eq.0) then !UPDATE OF STATE
          call vcopy(v(isbk1:iebk1,ntargd),v(isbk1:iebk1,1))
          if(id_mapping.eq.0) ntargd=1
        end if
      end if

      deallocate(ene_time)

      return
      end
