      subroutine trans_set_mag(hin,ise,jse,ib,i1,nx,mhx,lsta,lend)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,nx,ib,ix1,i1,jsta,jend,ista,iend,
     &           ksta,kend,isize,jsize,ksize,mhx,jse,lsta(*),lend(*)
#ifdef cmplx_v
      complex(8) :: hin(*),hx,hy,hz
      complex(8),
#else
      real(8) :: hin(*),hx,hz
      real(8),
#endif
     &  allocatable :: tmp(:,:),tmp0(:,:)

      call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),np_vec,
     &                 myid_vec,jsta,jend,jsize)
      call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),
     &                 np_(ise),myid_(ise),ista,iend,isize)
      call para_ranges(jsta,jend,np_(jse),myid_(jse),
     &                 ksta,kend,ksize)

      select case(ise)
      case(1)
        allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),ksta:kend))
        call gc2d(hin,isize,
     &            ksize,tmp,block(ise,nx,mhx)%sizex(ib,i1),
     &            np_sys,newcomm_sys)

        allocate(tmp0(block(ise,nx,mhx)%sizex(ib,i1),jsta:jend))
        call gr2d(tmp,block(ise,nx,mhx)%sizex(ib,i1)*ksize,
     &            tmp0,np_env,newcomm_env)
        deallocate(tmp)

        allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),
     &               block(ise,nx,mhx)%sizex(ib,i1)))
        call gr2d(tmp0,block(ise,nx,mhx)%sizex(ib,i1)*jsize,
     &            tmp,np_vec,newcomm_vec)

        hx=-one*fmag(1,nse(1)+1)*cmag(1)
#ifdef cmplx_v
        hy=cmplx(0.d0,fmag(2,nse(1)+1),kind=8)*cmag(2)
#endif
        hz=-one*fmag(3,nse(1)+1)*dble(iud(i1,1)-iud(i1,2))*cmag(3)

      case(2)
        allocate(tmp(jsta:jend,ista:iend))
        call gc2d(hin,ksize,
     &            isize,tmp,block(ise,nx,mhx)%sizex(ib,i1),
     &            np_sys,newcomm_sys)

        allocate(tmp0(block(ise,nx,mhx)%sizex(ib,i1),ista:iend))
        call gc2d(tmp,jsize,isize,tmp0,
     &            block(ise,nx,mhx)%sizex(ib,i1),np_vec,
     &            newcomm_vec)
        deallocate(tmp)

        allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),
     &               block(ise,nx,mhx)%sizex(ib,i1)))
        call gr2d(tmp0,block(ise,nx,mhx)%sizex(ib,i1)*isize,
     &            tmp,np_env,newcomm_env)

        hx=-one*fmag(1,nsite-nse(2))*cmag(1)
#ifdef cmplx_v
        hy=cmplx(0.d0,-fmag(2,nsite-nse(2)),kind=8)*cmag(2)
#endif
        hz=-one*fmag(3,nsite-nse(2))*dble(iud(i1,1)-iud(i1,2))*cmag(3)
      end select

! --- X-DIRECTION
      if(id_space.eq.0) then
        if(i1.lt.nfr) then
!$OMP PARALLEL DO
          do ix1=1,block(ise,nx,mhx)%sizex(ib,i1+1)
            if(ix1.ge.lsta(i1+1).and.ix1.le.lend(i1+1)) then
              ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1+1)-1)
     &       =ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1+1)-1)+hx
            end if
          enddo
        end if

        if(i1.gt.1) then
!$OMP PARALLEL DO
          do ix1=1,block(ise,nx,mhx)%sizex(ib,i1-1)
            if(ix1.ge.lsta(i1-1).and.ix1.le.lend(i1-1)) then
              ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1-1)-1)
     &       =ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1-1)-1)+hx
            end if
          enddo
        end if

! --- Y-DIRECTION
#ifdef cmplx_v
        if(i1.lt.nfr) then
!$OMP PARALLEL DO
          do ix1=1,block(ise,nx,mhx)%sizex(ib,i1+1)
            if(ix1.ge.lsta(i1+1).and.ix1.le.lend(i1+1)) then
              ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1+1)-1)
     &       =ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1+1)-1)-hy
            end if
          enddo
        end if

        if(i1.gt.1) then
!$OMP PARALLEL DO
          do ix1=1,block(ise,nx,mhx)%sizex(ib,i1-1)
            if(ix1.ge.lsta(i1-1).and.ix1.le.lend(i1-1)) then
              ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1-1)-1)
     &       =ast(i1,1)%ht(ix1,ix1+block(ise,nx,mhx)
     &          %stax(ib,i1-1)-1)+hy
            end if
          enddo
        end if
#endif
      end if

! --- Z-DIRECTION
!$OMP PARALLEL DO
      do ix1=1,block(ise,nx,mhx)%sizex(ib,i1)
        if(ix1.ge.lsta(i1).and.ix1.le.lend(i1)) then
          ast(i1,1)
     &      %ht(ix1,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
     &   =ast(i1,1)
     &      %ht(ix1,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
     &     +hz
        end if
      enddo

      deallocate(tmp,tmp0)

      return
      end
