      subroutine trans_wfunc1(iv,mhx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: mhx,iv,ib,jb,i,i0,k,k0,ix1,ix2,
     &           ista_s,iend_s,ista_e,iend_e,lsta,lend,lsize,ih
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: vt(:,:),vp(:,:),uv0(:,:),uvt(:,:)

      ih=1

      if(idmrg.eq.ndmrg) return

      if(allocated(vx)) deallocate(vx)

      if(mdDMRG.eq.1.and.iwf.eq.1) then
        allocate(vx(block(1,nse(1),mhx)%nbk))

        do ib=1,block(1,nse(1),mhx)%nbk
          jb=block(1,nse(1),mhx)%chbk(ib)
          if(jb.eq.0) cycle

          call para_range(1,block(1,nse(1),mhx)%size(ib),np_sys,
     &                    myid_sys,ista_s,iend_s)

          allocate(vx(ib)%ap(nfrx(2)),vx(ib)%jlb(nfrx(2)))

          do i=1,nfrx(2)
            vx(ib)%jlb(i)=0

            do i0=1,nfrx(1)
              if(bk(jb,1,ih)%ap(ad(i0,i))%nse(2).gt.vx(ib)%jlb(i)) then
                vx(ib)%jlb(i)=bk(jb,1,ih)%ap(ad(i0,i))%nse(2)
              end if
            enddo

            if(kid_old(jb,2).ne.myid_int) cycle

            allocate(vt(block(1,nse(1),mhx)%size(ib),
     &                  bk(jb,2,ih)%ivs(i):bk(jb,2,ih)%ive(i)))
!$OMP PARALLEL WORKSHARE
            vt=zero
!$OMP END PARALLEL WORKSHARE

            do i0=1,nfrx(1)
              if(bk(jb,2,ih)%sizex(i).gt.0.and.
     &           block(1,nse(1),mhx)%sizex(ib,i0).gt.0.and.
     &           block(1,nse(1),mhx)%size(ib).gt.0) then

                call para_range(1,block(1,nse(1),mhx)%sizex(ib,i0),
     &                          np_env,myid_env,lsta,lend)
                lsize=lend-lsta+1

                allocate(uv0(block(1,nse(1),mhx)%sizex(ib,i0),
     &                       block(1,nse(1),mhx)%ista0(ib,1):
     &                       block(1,nse(1),mhx)%iend0(ib,1)))

                call gc2d(block(1,nse(1),mhx)%b(ib)%s(i0)%uv,
     &                    lsize,block(1,nse(1),mhx)%isize0(ib,1),
     &                    uv0,block(1,nse(1),mhx)%sizex(ib,i0),
     &                    np_env,newcomm_env)

                allocate(uvt(bk(jb,1,ih)%sizex(i0),
     &                       block(1,nse(1),mhx)%size0(ib)))

                call gr2d(uv0,bk(jb,1,ih)%sizex(i0)
     &                   *block(1,nse(1),mhx)%isize0(ib,1),
     &                 uvt,np_sys,newcomm_sys)

                deallocate(uv0)

                if((bk(jb,2,ih)%ive(i)-bk(jb,2,ih)%ivs(i)+1)
     &           *(bk(jb,1,ih)%ive(i0)-bk(jb,1,ih)%ivs(i0)+1).gt.0) then
                  call XGEMM(chmm(2),chmm(1),
     &                 block(1,nse(1),mhx)%size(ib),
     &                 bk(jb,2,ih)%ive(i)-bk(jb,2,ih)%ivs(i)+1,
     &                 bk(jb,1,ih)%ive(i0)-bk(jb,1,ih)%ivs(i0)+1,
     &                 one,
     &                 uvt(bk(jb,1,ih)%ivs(i0),1),
     &                 bk(jb,1,ih)%sizex(i0),
     &                 v(jb,iv)%ap(ad(i0,i))%b(:,bk(jb,2,ih)%ivs(i)),
     &                 bk(jb,1,ih)%ive(i0)-bk(jb,1,ih)%ivs(i0)+1,
     &                 one,
     &                 vt,
     &                 block(1,nse(1),mhx)%size(ib))
                end if

                deallocate(uvt)

              end if
            enddo

            allocate(vp(block(1,nse(1),mhx)%size(ib),
     &                  bk(jb,2,ih)%ivs(i):bk(jb,2,ih)%ive(i)))

            call mpi_allreduce(vt,vp,block(1,nse(1),mhx)%size(ib)
     &             *(bk(jb,2,ih)%ive(i)-bk(jb,2,ih)%ivs(i)+1),
     &             mpi_kv,mpi_sum,newcomm_sys,ierr)

            deallocate(vt)

            allocate(vt(ista_s:iend_s,
     &                  bk(jb,2,ih)%ivs(i):bk(jb,2,ih)%ive(i)))

!$OMP PARALLEL DO
            do ix2=bk(jb,2,ih)%ivs(i),bk(jb,2,ih)%ive(i)
              do ix1=ista_s,iend_s
                vt(ix1,ix2)=vp(ix1,ix2)
              enddo
            enddo

            deallocate(vp)

            allocate(vx(ib)%ap(i)
     &               %b(ista_s:iend_s,bk(jb,2,ih)%sizex(i)))

            call gr2d(vt,(iend_s-ista_s+1)
     &                *(bk(jb,2,ih)%ive(i)-bk(jb,2,ih)%ivs(i)+1),
     &                vx(ib)%ap(i)%b,np_env,newcomm_env)

            deallocate(vt)
          enddo
        enddo

        call transwf1_bcast(1)

      elseif(mdDMRG.eq.2.and.iwf.eq.1) then
        allocate(vx(block(2,nse(2),mhx)%nbk))

        do ib=1,block(2,nse(2),mhx)%nbk
          jb=block(2,nse(2),mhx)%chbk(ib)
          if(jb.eq.0) cycle

          call para_range(1,block(2,nse(2),mhx)%size(ib),np_env,
     &                    myid_env,ista_e,iend_e)

          allocate(vx(ib)%ap(nfrx(1)),vx(ib)%jlb(nfrx(1)))

          do k=1,nfrx(1)
            vx(ib)%jlb(k)=0

            do k0=1,nfrx(2)
              if(bk(jb,1,ih)%ap(ad(k,k0))%nse(1).gt.vx(ib)%jlb(k)) then
                vx(ib)%jlb(k)=bk(jb,1,ih)%ap(ad(k,k0))%nse(1)
              end if
            enddo

            if(kid_old(jb,2).ne.myid_int) cycle

            allocate(vt(bk(jb,1,ih)%ivs(k):bk(jb,1,ih)%ive(k),
     &                  block(2,nse(2),mhx)%size(ib)))
!$OMP PARALLEL WORKSHARE
            vt=zero
!$OMP END PARALLEL WORKSHARE

            do k0=1,nfrx(2)
              if(bk(jb,1,ih)%sizex(k).gt.0.and.
     &           block(2,nse(2),mhx)%sizex(ib,k0).gt.0.and.
     &           block(2,nse(2),mhx)%size(ib).gt.0) then

                allocate(uv0(bk(jb,2,ih)%ivs(k0):bk(jb,2,ih)%ive(k0),
     &                       block(2,nse(2),mhx)%size0(ib)))

                call gr2d(block(2,nse(2),mhx)%b(ib)%s(k0)%uv,
     &                    (bk(jb,2,ih)%ive(k0)-bk(jb,2,ih)%ivs(k0)+1)
     &                    *block(2,nse(2),mhx)%isize0(ib,1),
     &                    uv0,np_sys,newcomm_sys)

                if((bk(jb,2,ih)%ive(k0)-bk(jb,2,ih)%ivs(k0)+1)
     &            *(bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1).gt.0) then
                  call XGEMM(chmm(1),chmm(1),
     &                 bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1,
     &                 block(2,nse(2),mhx)%size(ib),
     &                 bk(jb,2,ih)%ive(k0)-bk(jb,2,ih)%ivs(k0)+1,
     &                 one,
     &                 v(jb,iv)%ap(ad(k,k0))%b,
     &                 bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1,
     &                 uv0,
     &                 bk(jb,2,ih)%ive(k0)-bk(jb,2,ih)%ivs(k0)+1,
     &                 one,
     &                 vt,
     &                 bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1)
                end if

                deallocate(uv0)
              end if
            enddo

            allocate(vp(bk(jb,1,ih)%ivs(k):bk(jb,1,ih)%ive(k),
     &                  block(2,nse(2),mhx)%size(ib)))

            call mpi_allreduce(vt,vp,
     &           (bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1)
     &           *block(2,nse(2),mhx)%size(ib),
     &           mpi_kv,mpi_sum,newcomm_env,ierr)

            deallocate(vt)

            allocate(vt(bk(jb,1,ih)%ivs(k):bk(jb,1,ih)%ive(k),
     &                  ista_e:iend_e))

            if((iend_e-ista_e+1)
     &          *(bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1).gt.0) then
              call XCOPY((iend_e-ista_e+1)
     &                   *(bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1),
     &                   vp(:,ista_e:iend_e),1,vt,1)
            end if

            deallocate(vp)

            allocate(vx(ib)%ap(k)%b(bk(jb,1,ih)%sizex(k),ista_e:iend_e))

            if(iend_e-ista_e+1.eq.0) then
              deallocate(vt)
              cycle
            end if

            call gc2d(vt,bk(jb,1,ih)%ive(k)-bk(jb,1,ih)%ivs(k)+1,
     &                iend_e-ista_e+1,vx(ib)%ap(k)%b,
     &                bk(jb,1,ih)%sizex(k),np_sys,newcomm_sys)

            deallocate(vt)

          enddo
        enddo

        call transwf1_bcast(2)

      end if

      return
      end
